<?php
/**
* Global file including
*
* Global file to include the required files
*
* @copyright	CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author		Astalavista Development Team <thun@astalvista.ch>
* @access		public
* @module		includer
* @modulegroup	core
* @version		1.0.0
*/

//Security-Check
if (eregi("API.php",$_SERVER['PHP_SELF'])) {
    Header("Location: index.php");
    die();
}


if (file_exists(ASCMS_DOCUMENT_ROOT.'/config/version.php')) {
	require_once ASCMS_DOCUMENT_ROOT.'/config/version.php';
} else {
	die("PATH ERROR: please check your \$_PATHCONFIG[\"ascms_root_offset\"] variable in the configuration.php file!");
}

require_once ASCMS_CORE_PATH.'/validator.inc.php';
require_once ASCMS_LIBRARY_PATH.'/PEAR/HTML/Template/Sigma/Sigma.php';
// require_once ASCMS_LIBRARY_PATH.'/phplib/db_mysql.class.php';
require_once ASCMS_LIBRARY_PATH.'/phplib/db_mysql.inc';
require_once ASCMS_CORE_PATH.'/database.php';
require_once ASCMS_LIBRARY_PATH.'/adodb/adodb.inc.php';

// Includes the phplib databse extention class
require_once ASCMS_CORE_PATH.'/db_extends.class.php';

// Includes all framework files
require_once (ASCMS_FRAMEWORK_PATH . "/framework.php");


require_once ASCMS_CORE_PATH.'/paging.class.php';
require_once ASCMS_CORE_PATH.'/session.class.php';
require_once ASCMS_CORE_PATH.'/auth.class.php';
require_once ASCMS_CORE_PATH.'/Init.class.php';
require_once ASCMS_CORE_PATH.'/permission.class.php';

if (isset($adminPage) && $adminPage ) {
	require_once ASCMS_CORE_PATH.'/Modulechecker.class.php';
	require_once ASCMS_CORE_PATH.'/wysiwyg.class.php';
    require_once ASCMS_CORE_PATH.'/ContentSitemap.class.php';
   	require_once ASCMS_CORE_PATH.'/adminNavigation.class.php';
} else {
    require_once ASCMS_CORE_PATH.'/Navigation.class.php';
   	require_once ASCMS_CORE_MODULE_PATH.'/stats/lib/statsLib.class.php';
    require_once ASCMS_CORE_PATH.'/Security.class.php';
}

/**
* Show formatted date
*
* @param     int        $unixtimestamp
* @return    string     $formattedDate
*/
function showFormattedDate($unixtimestamp = "")
{
	global $_CORELANG;
	$months = explode(",",$_CORELANG['TXT_MONTH_ARRAY']);
	$weekday = explode(",",$_CORELANG['TXT_DAY_ARRAY']);
	
	if (empty($unixtimestamp)) {
        $date = date("w j n Y");
	} else {
		$date = date("w j n Y", $unixtimestamp);
	}
	
	list($wday,$mday,$month,$year) = split("( )",$date); 	
	$month -= 1; 
	$formattedDate = "$weekday[$wday], $mday. $months[$month] $year"; 	
	return $formattedDate;
}



/**
* Checks and cleans strings
*
* @author    Ivan Schmid <ivan.schmid@astalavista.ch>  
* @param     string     $string
* @return    string     $string (cleaned)                                                                              
*/
function strcheck(&$string)
{
   $clean_string = strtolower($string);
   $clean_string = rawurldecode($clean_string);
   $clean_string = html_entity_decode($clean_string);

   $from = ' ';
   $to   = 'aaaaaaceeeeiiiinoooooosuuuuuyyyz_';
   $clean_string = strtr($clean_string, $from, $to);

   $replace = array('' => 'th', '' => 'th', '' => 'dh', '' => 'dh',
                    '' => 'ss', '' => 'oe', '' => 'oe', '' => 'ae',
                    '' => 'ae', '$' => 's',  '' => 'y');
   $clean_string = strtr($clean_string, $replace);

   $clean_string = ereg_replace("[^a-z0-9._]", "", $clean_string);
   return $clean_string;
}
?>
