<?php
/**
* Class News
*
* @copyright CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author Astalavista Development Team <thun@astalvista.ch>         
* @module news
* @modulegroups core_modules                    
* @access public
* @version 1.0.0                                        
*/


require_once ASCMS_CORE_MODULE_PATH . '/news/xmlfeed.class.php';
require_once ASCMS_CORE_MODULE_PATH . '/news/newsLib.class.php';


class newsManager extends newsLibrary {
    var $_objTpl;
	var $pageTitle;
	var $pageContent;
	var $statusMessage;
	var $_selectedLang;
	var $langId;
	var $arrSettings = array();

	
	/**
    * Constructor
    *
    * @param  string  
    * @access public
    */
    function NewsManager(){ 
    	global  $_ARRAYLANG, $objInit, $objTemplate;
				
        $this->_objTpl = &new HTML_Template_Sigma(ASCMS_CORE_MODULE_PATH.'/news/template');
        $this->_objTpl->setErrorHandling(PEAR_ERROR_DIE);
        
        $objTemplate->setVariable("CONTENT_NAVIGATION","<a href='?cmd=news'>".$_ARRAYLANG['TXT_NEWS_MANAGER']."</a>&nbsp;&nbsp;
                           <a href='?cmd=news&amp;act=add'>".$_ARRAYLANG['TXT_CREATE_NEWS']."</a>&nbsp;&nbsp; 
                           <a href='?cmd=news&amp;act=newscat'>".$_ARRAYLANG['TXT_CATEGORY_MANAGER']."</a>&nbsp;&nbsp;
        				   <a href='?cmd=news&amp;act=settings'>".$_ARRAYLANG['TXT_NEWS_SETTINGS']."</a>" );

        $this->pageTitle = $_ARRAYLANG['TXT_NEWS_MANAGER'];
        $this->langId=$objInit->userFrontendLangId;
        $this->getSettings();
    }

    
    /**
    * Do the requested newsaction
    *  
    * @global	 object    $objTemplate 
    * @return    string    parsed content                                                                               
    */
    function getPage(){   	
    	global $objTemplate;
    	
    	if(!isset($_GET['act'])){
    	    $_GET['act']="";	
    	}
    	    	
        switch($_GET['act']){
			case "add":
		        $this->add();	
			break;
									    
			case "edit":
				$this->edit();
			break;
			
			case "delete":
			    $this->delete();
			    $this->overview();
			break;
			
			case "update":
			    $this->update();
			    $this->overview();
			break;
			
			case "newscat":
			    $this->manageCategories();
			    break;
			    
			case "delcat":
			    $this->deleteCat();
			    $this->manageCategories();
			    break;		

			case "changeStatus":
				$this->changeStatus();
				$this->overview();
				break;
						
			case "settings":
				$this->settings();
				break;
						   
			 case "rss":
			   $this->rss();
			   break;	 	
					
			default: 
			    (intval($this->arrSettings['news_settings_activated'])==0) ? $this->settings() : $this->overview();	
    	}
		
		$objTemplate->setVariable(array(
			'CONTENT_TITLE'				=> $this->pageTitle,
			'CONTENT_STATUS_MESSAGE'	=> $this->statusMessage,
			'ADMIN_CONTENT'				=> $this->_objTpl->get()
		));
    } 
    
    
    
    /**
    * List up the news for edit or delete 
    * 
    * @global	 object    $objDatabase    
    * @param     integer   $newsid
    * @param     string	   $what
    * @access  private                                                                               
    */
    function overview()
    {
    	global $objDatabase, $_ARRAYLANG, $_CONFIG;
    	
    	// initialize variables  	
    	$paging = "";
    	
    	$this->_objTpl->loadTemplateFile('module_news_overview.html',true,true);
		$this->pageTitle = $_ARRAYLANG['TXT_NEWS_MANAGER'];
    	
    	$this->_objTpl->setVariable(array(
    	    'TXT_EDIT_NEWS_MESSAGE'      => $_ARRAYLANG['TXT_EDIT_NEWS_MESSAGE'],
    	    'TXT_EDIT_NEWS_ID'           => $_ARRAYLANG['TXT_EDIT_NEWS_MESSAGE'],
    	    'TXT_ARCHIVE'                => $_ARRAYLANG['TXT_ARCHIVE'],
    	    'TXT_DATE'                   => $_ARRAYLANG['TXT_DATE'],
    	    'TXT_TITLE'                  => $_ARRAYLANG['TXT_TITLE'],
    	    'TXT_USER'                   => $_ARRAYLANG['TXT_USER'],
    	    'TXT_LAST_EDIT'              => $_ARRAYLANG['TXT_LAST_EDIT'],  	    
    	    'TXT_ACTION'                 => $_ARRAYLANG['TXT_ACTION'],
    	    'TXT_CATEGORY'               => $_ARRAYLANG['TXT_CATEGORY'],
            'TXT_CONFIRM_DELETE_DATA'    => $_ARRAYLANG['TXT_NEWS_DELETE_CONFIRM'],
            'TXT_ACTION_IS_IRREVERSIBLE' => $_ARRAYLANG['TXT_ACTION_IS_IRREVERSIBLE'],	
            'TXT_SELECT_ALL'             => $_ARRAYLANG['TXT_SELECT_ALL'],
            'TXT_REMOVE_SELECTION'       => $_ARRAYLANG['TXT_REMOVE_SELECTION'],   
            'TXT_EDIT'                   => $_ARRAYLANG['TXT_EDIT'],
            'TXT_DELETE'				 => $_ARRAYLANG['TXT_DELETE'],
            'TXT_DELETE_MARKED'          => $_ARRAYLANG['TXT_DELETE_MARKED'],      
            'TXT_MARKED'                 => $_ARRAYLANG['TXT_MARKED'], 
            'TXT_ACTIVATE'               => $_ARRAYLANG['TXT_ACTIVATE'],	
            'TXT_DEACTIVATE'             => $_ARRAYLANG['TXT_DEACTIVATE'],  
            'TXT_STATUS'                 => $_ARRAYLANG['TXT_STATUS'],                   	    
    	));
		
		$query = "SELECT n.id AS id,	
		                 n.date AS date, 	
		                 n.changelog AS changelog, 			
		                 n.title AS title,
		                 n.status AS status,
		                 l.name AS name,
		                 nc.name AS catname,
		                 u.username AS username 
		            FROM ".DBPREFIX."module_news_categories AS nc,
		                 ".DBPREFIX."module_news AS n, 
		                 ".DBPREFIX."languages AS l, 
				         ".DBPREFIX."access_users AS u
		           WHERE n.lang=l.id 
		             AND n.lang=".$this->langId." 
		             AND nc.catid=n.catid 
		             AND u.id=n.userid
		        ORDER BY n.id DESC";
		
		$objResult = $objDatabase->Execute($query);
		$count = $objResult->RecordCount();
		$pos = (isset($_GET['pos'])) ? intval($_GET['pos']) : 0;
		if ($count>intval($_CONFIG['corePagingLimit'])) {
		    $paging = getPaging($count, $pos, "&amp;cmd=news", $_ARRAYLANG['TXT_NEWS_MESSAGES'],true);
		}
		$objResult = $objDatabase->SelectLimit($query, $_CONFIG['corePagingLimit'], $pos);
        
		if($count<1) {
		    $this->_objTpl->hideBlock('newstable');		
		} else {
			$this->_objTpl->setCurrentBlock('newsrow');
			if ($objResult !== false) {
				while (!$objResult->EOF) {
		            ($i % 2) ? $class = "row2" : $class = "row1";
		            $i++;
		            
		            $statusPicture = "status_red.gif";
					if($objResult->fields['status']==1) {
					    $statusPicture = "status_green.gif";
					}
		            
				    $this->_objTpl->setVariable(array(
		                'NEWS_ID'         =>$objResult->fields['id'],
		                'NEWS_DATE'       =>date(ASCMS_DATE_FORMAT, $objResult->fields['date']),
		                'NEWS_TITLE'      =>stripslashes($objResult->fields['title']),
		                'NEWS_USER'       =>$objResult->fields['username'],
		                'NEWS_CHANGELOG'  =>date(ASCMS_DATE_FORMAT, $objResult->fields['changelog']),
		                'NEWS_LIST_PARSING'    =>$paging,
		                'NEWS_CLASS'      =>$class,
		                'NEWS_CATEGORY'   =>stripslashes($objResult->fields['catname']),
		                'NEWS_STATUS'     =>$objResult->fields['status'],
		                'NEWS_STATUS_PICTURE' => $statusPicture,                 
					));
					$this->_objTpl->parseCurrentBlock();
					$objResult->MoveNext();
				}
			}
		}
    }

    
  
    
    /**
    * adds a news entry
    *
    * @param     integer   $newsid -> the id of the news entry
    * @return    boolean   result                                                                              
    */
    function add(){
	    global $_ARRAYLANG;

    	$this->_objTpl->loadTemplateFile('module_news_modify.html',true,true);
		$this->pageTitle = $_ARRAYLANG['TXT_CREATE_NEWS'];	        
	    
	    $this->_objTpl->setVariable(array(
	        'TXT_NEWS_MESSAGE'    	 => $_ARRAYLANG['TXT_NEWS_MESSAGE'],
	        'TXT_TITLE'           	 => $_ARRAYLANG['TXT_TITLE'],
	        'TXT_CATEGORY'        	 => $_ARRAYLANG['TXT_CATEGORY'],
	        'TXT_HYPERLINKS'      	 => $_ARRAYLANG['TXT_HYPERLINKS'],
	        'TXT_EXTERNAL_SOURCE' 	 => $_ARRAYLANG['TXT_EXTERNAL_SOURCE'],
	        'TXT_LINK'            	 => $_ARRAYLANG['TXT_LINK'],
	        'TXT_NEWS_CONTENT'    	 => $_ARRAYLANG['TXT_NEWS_CONTENT'],
	        'TXT_STORE'           	 => $_ARRAYLANG['TXT_STORE'],
	        'TXT_DATE'				 => $_ARRAYLANG['TXT_DATE'],
	        'TXT_PUBLISHING'      	 => $_ARRAYLANG['TXT_PUBLISHING'],
	        'TXT_STARTDATE'       	 => $_ARRAYLANG['TXT_STARTDATE'],
	        'TXT_ENDDATE'         	 => $_ARRAYLANG['TXT_ENDDATE'],	
	        'TXT_OPTIONAL'           => $_ARRAYLANG['TXT_OPTIONAL'],	
	        'TXT_ACTIVE'             => $_ARRAYLANG['TXT_ACTIVE'],	        			        
			'NEWS_TEXT'           	 => get_wysiwyg_editor('newsText', '', 'active'),
			'NEWS_FORM_ACTION'       => "add",
			'NEWS_STORED_FORM_ACTION'=> "add",
			'NEWS_STATUS'         	 => "checked",			   		    
			'NEWS_ID'         		 => "",
			'NEWS_TOP_TITLE'         => $_ARRAYLANG['TXT_CREATE_NEWS'],
			'NEWS_CAT_MENU'          => $this->getCategoryMenu($this->langId),
			'NEWS_STARTDATE'         => "",
			'NEWS_ENDDATE'           => "",	
			'NEWS_DATE'              => date("Y-m-d"),			
			'NEWS_CREATE_DATE'		 => date(ASCMS_DATE_FORMAT)
		));
		
		if (isset($_POST['newsTitle']) AND !empty($_POST['newsTitle'])){
    	    $this->insert();
    	    $this->createRSS();
    	    $this->overview();       	               
        }  	        
    }     


    
    
    /**
    * Deletes a news entry
    *  
    * @global	 object    $objDatabase   
    * @global	 array     $_ARRAYLANG       
    * @return    -                                                                             
    */
    function delete(){
	    global $objDatabase, $_ARRAYLANG;
	    
	    $newsId = "";
	    if(isset($_GET['newsId'])){
	    	$newsId = intval($_GET['newsId']);			    
		    if ($objDatabase->Execute("DELETE FROM ".DBPREFIX."module_news WHERE id = ".$newsId) !== false) {
		    	$this->statusMessage=$_ARRAYLANG['TXT_DATA_RECORD_DELETED_SUCCESSFUL'];
		    	$this->createRSS();
		    } else {
		    	$this->statusMessage=$_ARRAYLANG['TXT_DATABASE_QUERY_ERROR'];
		    }
	    }
	    			
		if(is_array($_POST['selectedNewsId'])){
			foreach ($_POST['selectedNewsId'] AS $value){
				if (!empty($value)){
				    if ($objDatabase->Execute("DELETE FROM ".DBPREFIX."module_news WHERE id = ".intval($value)) !== false) {
				    	$this->statusMessage=$_ARRAYLANG['TXT_DATA_RECORD_DELETED_SUCCESSFUL'];
				    	$this->createRSS();
				    } else {
			            $this->statusMessage=$_ARRAYLANG['TXT_DATABASE_QUERY_ERROR'];
				    }				    																
				} 				 	
			}
		}	  	       
    }    

    
    
    
    /**
    * Edit the news
    *
    * @global    object     $objDatabase
    * @param     string     $pageContent                                                                             
    */
    function edit(){ 	   	
    	global $objDatabase,$_ARRAYLANG;   
    	
		$status = "";	
		$startDate = "";
		$endDate = "";	    		
		
    	$this->_objTpl->loadTemplateFile('module_news_modify.html',true,true);
		$this->pageTitle = $_ARRAYLANG['TXT_EDIT_NEWS_CONTENT'];		
		
		$this->_objTpl->setVariable(array(
		    'TXT_NEWS_MESSAGE'    => $_ARRAYLANG['TXT_NEWS_MESSAGE'],
		    'TXT_TITLE'           => $_ARRAYLANG['TXT_TITLE'],
		    'TXT_CATEGORY'        => $_ARRAYLANG['TXT_CATEGORY'],
		    'TXT_HYPERLINKS'      => $_ARRAYLANG['TXT_HYPERLINKS'],
		    'TXT_EXTERNAL_SOURCE' => $_ARRAYLANG['TXT_EXTERNAL_SOURCE'],
		    'TXT_LINK'            => $_ARRAYLANG['TXT_LINK'],
		    'TXT_NEWS_CONTENT'    => $_ARRAYLANG['TXT_NEWS_CONTENT'],
		    'TXT_STORE'           => $_ARRAYLANG['TXT_STORE'],
	        'TXT_PUBLISHING'      => $_ARRAYLANG['TXT_PUBLISHING'],
	        'TXT_STARTDATE'       => $_ARRAYLANG['TXT_STARTDATE'],
	        'TXT_ENDDATE'         => $_ARRAYLANG['TXT_ENDDATE'],	
	        'TXT_OPTIONAL'        => $_ARRAYLANG['TXT_OPTIONAL'],	
	        'TXT_ACTIVE'          => $_ARRAYLANG['TXT_ACTIVE'],			    
	        'TXT_DATE'			  => $_ARRAYLANG['TXT_DATE']
		));
		
		$newsid = intval($_REQUEST['newsId']);		
		$objResult = $objDatabase->SelectLimit("SELECT catid,
						   date,
						   lang,
						   id,
						   title,
						   text,
						   source,
						   url1,
						   url2,
						   startdate,
						   enddate,
						   status 
		              FROM ".DBPREFIX."module_news 
		             WHERE id = '".$newsid."'", 1);
		if ($objResult !== false && !$objResult->EOF) {
			$newsCat=$objResult->fields['catid'];
			$id = $objResult->fields['id'];
			$newsText = stripslashes($objResult->fields['text']);
			
			if($objResult->fields['status']==1){
				$status = "checked";
			}		         
			if($objResult->fields['startdate']!="0000-00-00"){
				$startDate = $objResult->fields['startdate'];
			}			
			if($objResult->fields['enddate']!="0000-00-00"){
				$endDate = $objResult->fields['enddate'];
			}		
			
			$this->_objTpl->setVariable(array(
				'NEWS_ID'		    => $id,
				'NEWS_STORED_ID'	=> $id,
				'NEWS_TITLE'		=> htmlspecialchars(stripslashes($objResult->fields['title'])),
				'NEWS_TEXT'		    => get_wysiwyg_editor('newsText', $newsText, 'active'),			
				'NEWS_SOURCE'	    => $objResult->fields['source'],
				'NEWS_URL1'		    => $objResult->fields['url1'],
				'NEWS_URL2'		    => $objResult->fields['url2'],
				'NEWS_CREATE_DATE'	=> date(ASCMS_DATE_FORMAT,$objResult->fields['date']),
				'NEWS_STARTDATE'	=> $startDate,
				'NEWS_ENDDATE'		=> $endDate,
				'NEWS_STATUS'		=> $status,	
				'NEWS_DATE'         => date("Y-m-d"),			
			));
		}
	
		$this->_objTpl->setVariable("NEWS_CAT_MENU",$this->getCategoryMenu($this->langId, $newsCat));
		$this->_objTpl->setVariable("NEWS_FORM_ACTION","update");
	    $this->_objTpl->setVariable("NEWS_STORED_FORM_ACTION","update"); 
	    $this->_objTpl->setVariable("NEWS_TOP_TITLE",$_ARRAYLANG['TXT_EDIT_NEWS_CONTENT']);    
    }    
    
    

    /**
    * Update news
    * 
    * @global	 object    $objDatabase     
    * @global	 array     $_POST[*] 
    * @param     integer   $newsid
    * @return    boolean   result                                                                              
    */
    function update(){
	    global $objDatabase, $_ARRAYLANG, $_CONFIG;
			    
	    if (isset($_GET['newsId'])) {
	    	$id = intval($_GET['newsId']);
		    $userId = intval($_SESSION['auth']['userid']);
		    $changelog = mktime();
		    $date = mktime(substr($_POST['newsDate'],0,2),substr($_POST['newsDate'],3,2),substr($_POST['newsDate'],6,2),substr($_POST['newsDate'],13,2),substr($_POST['newsDate'],9,2),substr($_POST['newsDate'],16));
		    $title = contrexx_strip_tags($_POST['newsTitle']); 
		    $text = contrexx_addslashes($_POST['newsText']); 
		    // $title= str_replace("","ss",$title); 
		    $text = $this->filterBodyTag($text);
		    // $text = str_replace("","ss",$text); 		
		    $source	= contrexx_strip_tags($_POST['newsSource']); 
		    $url1 = contrexx_strip_tags($_POST['newsUrl1']); 
		    $url2 = contrexx_strip_tags($_POST['newsUrl2']); 
		    $catId = intval($_POST['newsCat']);	
		        
		    $status = empty($_POST['status']) ? $status = 0 : intval($_POST['status']);

		    $startDate = contrexx_strip_tags($_POST['startDate']);	
		    $endDate = contrexx_strip_tags($_POST['endDate']);    
		    	    	    		    
		    // $finishednewstext = $newstext."<br>".$_ARRAYLANG['TXT_LAST_EDIT'].": ".$date;		    
		    $objResult = $objDatabase->Execute("UPDATE ".DBPREFIX."module_news
					       SET title='".$title."', 
					       	   date='".$date."',
		                       text='".$text."', 
		                       source='".$source."', 
		                       url1='".$url1."', 
		                       url2='".$url2."', 
		                       catid='".$catId."', 
		                       lang='".$this->langId."',
		                       userid = '".$userId."',
		                       status = '".$status."',
		                       startdate = '".$startDate."',
		                       enddate = '".$endDate."',
		                       changelog = '".$changelog."'
	                     WHERE id = '".$id."'");
		   if($objResult === false){
		   	    $this->statusMessage=$_ARRAYLANG['TXT_DATABASE_QUERY_ERROR'];
		   } else {
	            $this->createRSS();
	            $this->statusMessage=$_ARRAYLANG['TXT_DATA_RECORD_UPDATED_SUCCESSFUL'];
		   }
        }
    }


    
    
    
    
    /**
    * Update news
    *
    * @global	 object    $objDatabase      
    * @global	 array     $_POST[*] 
    * @param     integer   $newsid
    * @return    boolean   result                                                                              
    */
	function changeStatus(){
		global $objDatabase, $_ARRAYLANG, $_CONFIG;
		   	
		if(isset($_POST['deactivate']) AND !empty($_POST['deactivate'])){	
			$status = 0;
		}		
		if(isset($_POST['activate']) AND !empty($_POST['activate'])){	
			$status = 1;
		}		
		if(isset($status)){				
			if(is_array($_POST['selectedNewsId'])){
				foreach ($_POST['selectedNewsId'] as $value){
					if (!empty($value)){
					    $objResult = $objDatabase->Execute("UPDATE ".DBPREFIX."module_news SET status = '".$status."' WHERE id = '".intval($value)."'");
					} 
				    if($objResult === false){
				   	    $this->statusMessage=$_ARRAYLANG['TXT_DATABASE_QUERY_ERROR'];
				    } else{
			            $this->statusMessage=$_ARRAYLANG['TXT_DATA_RECORD_UPDATED_SUCCESSFUL'];
				    }				 	
				}
			}	
		}
    }    

    
    
    
    /**
    * Insert news
    *
    * @global	 object    $objDatabase   
    * @global	 array     $_POST[*]   
    * @return    boolean   result                                                                              
    */
    function insert(){
	    global $objDatabase, $_ARRAYLANG;

	    $date = mktime(substr($_POST['newsDate'],0,2),substr($_POST['newsDate'],3,2),substr($_POST['newsDate'],6,2),substr($_POST['newsDate'],13,2),substr($_POST['newsDate'],9,2),substr($_POST['newsDate'],16));
	    $newstitle = contrexx_strip_tags($_POST['newsTitle']); 
	    $newstext = contrexx_addslashes($_POST['newsText']); 
	    // $newstitle = str_replace("","ss",$newstitle); 
	    // $newstext = str_replace("","ss",$newstext); 
	    $newstext = $this->filterBodyTag($newstext);
	    $newssource	= contrexx_strip_tags($_POST['newsSource']); 
	    $newsurl1 = contrexx_strip_tags($_POST['newsUrl1']); 
	    $newsurl2 = contrexx_strip_tags($_POST['newsUrl2']); 
	    $newscat = intval($_POST['newsCat']);
	    $userid = intval($_SESSION['auth']['userid']);
	    $startDate = contrexx_strip_tags($_POST['startDate']);
	    $endDate = contrexx_strip_tags($_POST['endDate']);	    
	    $status = intval($_POST['status']);
	    if(empty($status)) {
	        $status = 0;
	        $startDate = "";
	        $endDate = "";
	    }
	
	    $objResult = $objDatabase->Execute("INSERT INTO ".DBPREFIX."module_news 
	                            ( id,
							      date,
							      title,
							      text,
							      source,
							      url1,
							      url2,
							      catid,
							      lang, 
								  startdate,
								  enddate,
								  status,
							      userid, 
							      changelog )
	                     VALUES ( '',
	                              '$date', 
								  '$newstitle', 
								  '$newstext', 
								  '$newssource', 
								  '$newsurl1', 
								  '$newsurl2', 
								  '$newscat',
								  '$this->langId',
	                              '$startDate',
	                              '$endDate',
	                              '$status',
								  '$userid',
								  '$date')");
	    
        if ($objResult !== false){
    	    $this->statusMessage=$_ARRAYLANG['TXT_DATA_RECORD_ADDED_SUCCESSFUL'];
        } else{
        	$this->statusMessage=$_ARRAYLANG['TXT_DATABASE_QUERY_ERROR'];
        }
    }   
    

    
    
    /**
    * Add or edit the news categories
    *
    * @global    object     $objDatabase
    * @global    array      $_ARRAYLANG[news*]
    * @param     string     $pageContent                                                                           
    */
    function manageCategories(){
    	global $objDatabase, $_ARRAYLANG;
    	
    	$this->_objTpl->loadTemplateFile('module_news_category.html',true,true);
		$this->pageTitle = $_ARRAYLANG['TXT_CATEGORY_MANAGER'];	    	
    	   	
    	$this->_objTpl->setVariable(array(
    	    'TXT_ADD_NEW_CATEGORY'                       => $_ARRAYLANG['TXT_ADD_NEW_CATEGORY'],
    	    'TXT_NAME'                                   => $_ARRAYLANG['TXT_NAME'],
    	    'TXT_ADD'                                    => $_ARRAYLANG['TXT_ADD'],
    	    'TXT_CATEGORY_LIST'                          => $_ARRAYLANG['TXT_CATEGORY_LIST'],
    	    'TXT_ID'                                     => $_ARRAYLANG['TXT_ID'],
    	    'TXT_ACTION'                                 => $_ARRAYLANG['TXT_ACTION'],
    	    'TXT_ACCEPT_CHANGES'                         => $_ARRAYLANG['TXT_ACCEPT_CHANGES'],
    	    'TXT_CONFIRM_DELETE_DATA'                    => $_ARRAYLANG['TXT_CONFIRM_DELETE_DATA'],
    	    'TXT_ACTION_IS_IRREVERSIBLE'                 => $_ARRAYLANG['TXT_ACTION_IS_IRREVERSIBLE'],
    	    'TXT_ATTENTION_SYSTEM_FUNCTIONALITY_AT_RISK' => $_ARRAYLANG['TXT_ATTENTION_SYSTEM_FUNCTIONALITY_AT_RISK']   	       	       	    
    	));
    	
    	$this->_objTpl->setGlobalVariable(array('TXT_DELETE' => $_ARRAYLANG['TXT_DELETE']));
    	
    	// Add a new category
    	if (isset($_POST['addCat']) AND ($_POST['addCat']==true)){
    		 $catName=contrexx_strip_tags($_POST['newCategorieName']);
    		 
    	     if($objDatabase->Execute("INSERT INTO ".DBPREFIX."module_news_categories (name,lang) 
    	                         VALUES ('$catName','$this->langId')") !== false) {
    	     	$this->statusMessage = $_ARRAYLANG['TXT_DATA_RECORD_ADDED_SUCCESSFUL'];
    	     } else {
    	     	$this->statusMessage = $_ARRAYLANG['TXT_DATABASE_QUERY_ERROR'];
    	     }
    		
    	}
    	
    	// Modify a new category
    	if (isset($_POST['modCat']) AND ($_POST['modCat']==true))
    	{
    		foreach ($_POST['newsCatName'] as $id => $name) 
		    {
				$name=contrexx_strip_tags($name);
				$id=intval($id);
				
			    if($objDatabase->Execute("UPDATE ".DBPREFIX."module_news_categories SET name='$name',lang=$this->langId WHERE catid=$id") !== false) {
			    	$this->statusMessage = $_ARRAYLANG['TXT_DATA_RECORD_UPDATED_SUCCESSFUL'];
			    } else {
			    	$this->statusMessage = $_ARRAYLANG['TXT_DATABASE_QUERY_ERROR'];
			    }
		    }
    	} 
    			
		$objResult = $objDatabase->Execute("SELECT catid, 
		                   name,
		                   lang
		              FROM ".DBPREFIX."module_news_categories 
		             WHERE lang=".$this->langId."
				  ORDER BY catid asc");
		
		$this->_objTpl->setCurrentBlock('newsRow');
		$i=0;
		
		if ($objResult !== false) {
			while (!$objResult->EOF) {
				$cssStyle = (($i % 2) == 0) ? "row1" : "row2";
				$this->_objTpl->setVariable(array(
				    'NEWS_ROWCLASS'   => $cssStyle,
					'NEWS_CAT_ID'	  => $objResult->fields['catid'],
					'NEWS_CAT_NAME'	  => stripslashes($objResult->fields['name'])
				));
				$this->_objTpl->parseCurrentBlock();
				$i++;
				$objResult->MoveNext();
			};
		}
    }



    
    
    /**
    * Delete the news categories
    *
    * @global    object     $objDatabase
    * @global    array      $_ARRAYLANG[news*]
    * @param     string     $pageContent                                                                           
    */
    function deleteCat(){
    	global $objDatabase, $_ARRAYLANG;

    	if(isset($_GET['catId'])) {
    	    $catId=intval($_GET['catId']);   	    
    	    $objResult = $objDatabase->Execute("SELECT id FROM ".DBPREFIX."module_news WHERE catid=".$catId);
    	    
    	    if ($objResult !== false) {
	    	    if (!$objResult->EOF) {
	    	         $this->statusMessage = $_ARRAYLANG['TXT_CATEGORY_NOT_DELETED_BECAUSE_IN_USE'];	
	    	    }
	    	    else {
	    	        if($objDatabase->Execute("DELETE FROM ".DBPREFIX."module_news_categories WHERE catid=".$catId) !== false) {
	    	            $this->statusMessage = $_ARRAYLANG['TXT_DATA_RECORD_DELETED_SUCCESSFUL'];
	    	        } else {
	    	        	$this->statusMessage = $_ARRAYLANG['TXT_DATABASE_QUERY_ERROR'];
	    	        }
	    	    }
    	    }
    	}
    }
        
    
    /**
    * Gets only the body content and deleted all the other tags
    *
    * @param     string     $fullContent      HTML-Content with more than BODY
    * @return    string     $content          HTML-Content between BODY-Tag                                                                
    */
    function filterBodyTag($fullContent){
	    $res=false;
	    $posBody=0;
	    $posStartBodyContent=0;
	    $res=preg_match_all("/<body[^>]*>/i", $fullContent, $arrayMatches);
	    if($res==true)
	    {
            $bodyStartTag = $arrayMatches[0][0];
            // Position des Start-Tags holen
            $posBody = strpos($fullContent, $bodyStartTag, 0);
            // Beginn des Contents ohne Body-Tag berechnen 
            $posStartBodyContent = $posBody + strlen($bodyStartTag);
	    }
	    $posEndTag=strlen($fullContent);
	    $res=preg_match_all("/<\/body>/i",$fullContent, $arrayMatches);
	    if($res==true)
	    {
            $bodyEndTag=$arrayMatches[0][0];
            // Position des End-Tags holen
            $posEndTag = strpos($fullContent, $bodyEndTag, 0);
            // Content innerhalb der Body-Tags auslesen
	     }
	     $content = substr($fullContent, $posStartBodyContent, $posEndTag  - $posStartBodyContent);
         return $content;
    }
    
    
    
    /**
    * Create the RSS-Feed
    *                                                            
    */    
    function createRSS(){
		global $_CONFIG;
		
		$objRSS = &new rssFeed();
		if(intval($this->arrSettings['news_feed_status'])==1) {	    			
			$objRSS->channelTitle = $this->arrSettings['news_feed_title'];
			$objRSS->channelDescription = $this->arrSettings['news_feed_description'];
			$objRSS->channelWebmaster = $_CONFIG['coreAdminEmail'];
		
			$objRSS->xmlType = "headlines";
			$objRSS->create();
					
			$objRSS->xmlType = "fulltext";	
			$objRSS->create();
		} else {
			$objRSS->delete();	
		}
    }

    
    
    
    
       
    function settings(){
    	global $objDatabase, $_ARRAYLANG;
    	
    	$this->pageTitle = $_ARRAYLANG['TXT_NEWS_SETTINGS'];
    	$this->_objTpl->loadTemplateFile('module_news_settings.html',true,true);
    	  	
    	// Store settings
    	if(isset($_POST['store'])) {  		
		    $objDatabase->Execute("UPDATE ".DBPREFIX."module_news_settings 
		                      SET value='".contrexx_strip_tags($_POST['newsFeedTitle'])."' 
		                    WHERE name = 'news_feed_title'");
    		
		    $objDatabase->Execute("UPDATE ".DBPREFIX."module_news_settings 
		                      SET value='".intval($_POST['newsFeedStatus'])."' 
		                    WHERE name = 'news_feed_status'");
		    
		    $objDatabase->Execute("UPDATE ".DBPREFIX."module_news_settings 
		                      SET value='".contrexx_strip_tags($_POST['newsFeedDescription'])."' 
		                    WHERE name = 'news_feed_description'");

		    $objDatabase->Execute("UPDATE ".DBPREFIX."module_news_settings 
		                      SET value='".intval($_POST['headlinesLimit'])."' 
		                    WHERE name = 'news_headlines_limit'");
		    
		    $objDatabase->Execute("UPDATE ".DBPREFIX."module_news_settings SET value='1' WHERE name = 'news_settings_activated'");		    
    		
    		$this->statusMessage = $_ARRAYLANG['TXT_NEWS_SETTINGS_SAVED'];
    		// renew the settings values
    		$this->getSettings();
    		$this->createRSS();    			 	
    	}
    	    	 
    	 // Show settings   	
		$objResult = $objDatabase->Execute("SELECT lang FROM ".DBPREFIX."languages WHERE id='".$this->langId."'");
		if ($objResult !== false) {
	    	$newsFeedPath =  "http://".$_SERVER['SERVER_NAME'].ASCMS_FEED_WEB_PATH."/news_headlines_".$objResult->fields['lang'].".xml";
		}

    	if(intval($this->arrSettings['news_feed_status'])==1){
    	    $status = "checked='checked'";
    		$icon = "<a href='".$newsFeedPath."' target='_blank'><img src='".ASCMS_CORE_MODULE_WEB_PATH."/news/images/rss.gif' border='0' title='".$newsFeedPath."' alt='".$newsFeedPath."'></a>";	
    	} else {
    		$status ="";
    		$icon ="";
    	}   	
    	
		$this->_objTpl->setVariable(array(
		    'NEWS_FEED_TITLE' => stripslashes($this->arrSettings['news_feed_title']),
		    'NEWS_FEED_STATUS' => $status,
		    'NEWS_FEED_ICON' => $icon,
		    'NEWS_FEED_DESCRIPTION' => stripslashes($this->arrSettings['news_feed_description']),
		    'NEWS_HEADLINES_LIMIT' =>(intval($this->arrSettings['news_headlines_limit'])),
		    'NEWS_FEED_PATH'    => $newsFeedPath,
		    'TXT_STORE'  => $_ARRAYLANG['TXT_STORE'],
		    'TXT_NAME'   => $_ARRAYLANG['TXT_NAME'],
		    'TXT_VALUE'  => $_ARRAYLANG['TXT_VALUE'],
		    'TXT_NEWS_SETTINGS'	=> $_ARRAYLANG['TXT_NEWS_SETTINGS'],
		    'TXT_NEWS_FEED_STATUS'=> $_ARRAYLANG['TXT_NEWS_FEED_STATUS'],
		    'TXT_NEWS_FEED_TITLE' => $_ARRAYLANG['TXT_NEWS_FEED_TITLE'],
		    'TXT_NEWS_FEED_DESCRIPTION' => $_ARRAYLANG['TXT_NEWS_FEED_DESCRIPTION'],
		    'TXT_NEWS_HEADLINES_LIMIT' => $_ARRAYLANG['TXT_NEWS_HEADLINES_LIMIT'],
		    'TXT_NEWS_SETTINGS_SAVED' => $_ARRAYLANG['TXT_NEWS_SETTINGS_SAVED']		    
		));  	
    }
}
?>