<?PHP
/**
* Modul Search
*
* Gets the Searching-Results from the DB
*
* @copyright CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author Astalavista Development Team <thun@astalvista.ch>
* @module search
* @modulegroup core_modules   
* @access public
* @version 1.0.3   
*/


//Security-Check
if (eregi("index.class.php",$_SERVER['PHP_SELF'])) {
    Header("Location: ?");
    die();
}

/**
* Gets the searchpage
*
* @global	 array     $_ARRAYLANG[search*] 
* @global	 array		$_CONFIG 
* @global	 array		$_GET['term']    
* @param     integer	$pos:  get the results from pos
* @param     string		$page_content: get the content from index.php
* @return    string		$tpl->parse(OUT, "CONTENT_OUTPUT" ): parsed page content                                                                                 
*/
function search_getSearchPage($pos, $page_content){
    global $_CONFIG, $_ARRAYLANG,$objDatabase;	
    $objTpl = &new HTML_Template_Sigma('.');
    $objTpl->setErrorHandling(PEAR_ERROR_DIE);
    $objTpl->setTemplate($page_content);
	$objTpl->setVariable("TXT_SEARCH", $_ARRAYLANG['TXT_SEARCH']);
    
    $term = ""; //$_SERVER['HTTP_HOST'];
    if(isset($_REQUEST['term'])&& strlen($_REQUEST['term'])>=3){
		$term = htmlentities(mysql_escape_string(stripslashes(trim($_REQUEST['term']))));
		$querynews=search_searchQuery("news",$term);
		$query=search_searchQuery("content",$term);
		$querydocsys = search_searchQuery("docsys",$term);
		$queryshop = search_searchQuery("shop",$term);
		$queryGalleryCats = search_searchQuery("gallery_cats",$term);
		$queryGalleryPics = search_searchQuery("gallery_pics",$term);
    }    
    
    //Prm: Query,Section,Cmd,PageVar
    $arrayContent=search_getResultArray($query,"","","page=",$term);
    $arrayNews=search_getResultArray($querynews,"news","details","newsid=",$term);
    $arrayDocsys = array();
    $arrayShopProducts = array();
    $arrayGalleryCats = array();
    $arrayGalleryPics = array();
    $arrTables = $objDatabase->MetaTables('TABLES');
    if (in_array(DBPREFIX."module_docsys",$arrTables)) {
       	$arrayDocsys=search_getResultArray($querydocsys,"docsys","details","id=",$term);
    }
    if (in_array(DBPREFIX."module_shop_products'",$arrTables)) {
        $arrayShopProducts=search_getResultArray($queryshop,"shop","","productId=",$term);
    }
    if (in_array(DBPREFIX."module_gallery_categories",$arrTables)) {
    	$arrayGalleryCats = search_getResultArray($queryGalleryCats,"gallery","showCat","cid=",$term);
    	$arrayGalleryPics = search_getResultArray($queryGalleryPics,"gallery","showCat","cid=",$term);
    }
    //**************************************
	//paging start
    //**************************************

    $arraySearchResults=array_merge($arrayContent,$arrayNews,$arrayDocsys,$arrayShopProducts,$arrayGalleryCats,$arrayGalleryPics);
    if(is_array($arraySearchResults)){
        usort($arraySearchResults, "search_comparison");
    }
    $countResults=sizeof($arraySearchResults);	
		
    
    if(!is_numeric($pos)){
        $pos = 0;
    }
    
    
    $paging = getPaging($countResults, $pos, "&amp;section=search&amp;term=$term", "<b>".$_ARRAYLANG['TXT_SEARCH_RESULTS']."</b>", true);
    $objTpl->setVariable("SEARCH_PAGING", "$paging");
    $term=stripslashes($term);
    $objTpl->setVariable("SEARCH_TERM",$term);
			
    //**************************************
    //  paging end
    //************************************** 
    //*************************************
    //  parsing start
    //*************************************
    
    if ($countResults > 0){
    	$searchComment=sprintf($_ARRAYLANG['TXT_SEARCH_RESULTS_ORDER_BY_RELEVANCE'],$term,$countResults);
        $objTpl->setVariable("SEARCH_TITLE",$searchComment."<br />");
        
        $arraySearchOut=array_slice($arraySearchResults,$pos,$_CONFIG['corePagingLimit']);
         
        foreach($arraySearchOut as $kk=>$details){
            $objTpl->setVariable("COUNT_MATCH",$_ARRAYLANG['TXT_RELEVANCE']." $details[Score]%");
            $objTpl->setVariable("LINK", "<b><a href=\"".$details['Link']."\" title=\"".$details['Title']."\">".$details['Title']."</a></b>");
            $objTpl->setVariable("SHORT_CONTENT", $details['Content']." ..<br />");
            $objTpl->parse("searchrow");
        }
    }	
    else
    {
		$noresult= ($term <>'') ? sprintf($_ARRAYLANG['TXT_NO_SEARCH_RESULTS'],$term) : sprintf("Bitte geben Sie ein Suchwort ein",$term);
		$objTpl->setVariable("LINK", $noresult);
		$objTpl->setVariable("SHORT_CONTENT","");
		$objTpl->setVariable("COUNT_MATCH", "");
		$objTpl->setVariable("SEARCH_TITLE", "");
		$objTpl->parse("searchrow");		
    }
    return $objTpl->get();
}


/**
* Get searchquery
*
* Gets the SQL-searching-string (for news or content search)
*
* @param  string	for search in news or content
* @param  string	replace the variable with the searching term
* @return string	SQL-Query with search term
*/
function search_searchQuery($section,$searchTerm)
{
    global $_LANGID;
    $query="";
    switch($section)
    {
        case "news":
            $query ="SELECT id AS id,
                            text AS content,
                            title AS title, 
                      MATCH (text,title) AGAINST ('%$searchTerm%') AS score
                       FROM ".DBPREFIX."module_news
                      WHERE text LIKE ('%$searchTerm%')
                         OR title LIKE ('%$searchTerm%')
		                    AND lang =".$_LANGID."
                        AND status = 1
                        AND (startdate<=CURDATE() OR startdate='0000-00-00')
                        AND (enddate>=CURDATE() OR enddate='0000-00-00')"; 				
        
			break;//
        case "content":
             $query="SELECT n.catid AS id, 
		                    m.name AS section, 
		                    n.cmd AS cmd, 
		                    c.id AS contentid, 
		                    c.content AS content, 
		                    c.title AS title, 
                      MATCH (content,title) AGAINST ('%$searchTerm%') AS score
                       FROM ".DBPREFIX."content AS c, 
                            ".DBPREFIX."content_navigation AS n,
                            ".DBPREFIX."modules AS m
                      WHERE (content LIKE ('%$searchTerm%')
                      	OR title LIKE ('%$searchTerm%'))
                        AND n.displaystatus ='on'
                        AND n.module =m.id
                        AND n.catid = c.id
						AND n.lang=".$_LANGID;	
            break;
        case "docsys":
             $query="SELECT id, 
		                    text AS content, 
                            title AS title,
                      MATCH (text,title) AGAINST ('%$searchTerm%') AS score
                       FROM ".DBPREFIX."module_docsys
                      WHERE text LIKE ('%$searchTerm%')
                         OR title LIKE ('%$searchTerm%')
                        AND lang=".$_LANGID."
                        AND status = 1";	
            break;
        case "shop":
             $query="SELECT id,
                            title, 
		                    description AS content,
                      MATCH (description,title) AGAINST ('%$searchTerm%') AS score
                       FROM ".DBPREFIX."module_shop_products
                      WHERE description LIKE ('%$searchTerm%')
                         OR title LIKE ('%$searchTerm%')             
                        AND status =1";	
            break;
		case "gallery_cats":
			$query = "SELECT id, name AS title, description AS content,
						MATCH (name,description) AGAINST ('%$searchTerm%') AS score
						FROM ".DBPREFIX."module_gallery_categories
						WHERE name LIKE ('%$searchTerm%')
							OR description LIKE ('%$searchTerm%')";
			break;
		case "gallery_pics":
			$query = "SELECT catid AS id, name AS title, path AS content,
						MATCH (name,path) AGAINST ('%$searchTerm%') AS score
						FROM ".DBPREFIX."module_gallery_pictures
						WHERE name LIKE ('%$searchTerm%')
							OR path LIKE ('%$searchTerm%')";
			break;
        default:
            break;
    }
    return $query;
}


/**
* Get resultarray
*
* Gets the results in an array
*
* @author  Christian Wehrli <christian.wehrli@astalavista.ch> 
* @global object	$objDatabase
* @param  string	$query			the searching query
* @param  string	$section_var	needed for section
* @param  string	$cmd_var		needed for cmd
* @param  string	$pagevar
* @return string	$term			search term
*/
function search_getResultArray($query,$section_var,$cmd_var,$pagevar,$term)
{
    global $_CONFIG, $objDatabase;
    
    $arraySearchResults = array();
    $objResult = $objDatabase->Execute($query);  
    $i=0;
    
    if ($objResult !== false) {
	    while (!$objResult->EOF) {
	        $i++;
	        $cmd=$objResult->fields['cmd'];
	        $section=$objResult->fields['section'];
	        
	        if ($section=="" && $section_var<>""){
	            $section=$section_var;
	        }
	        if ($cmd=="" && $cmd_var<>""){
	            $cmd=$cmd_var;
	        }
	
	        $temp_section	= ( ($section=="") ? "" : "&amp;section=$section" );
	        $temp_cmd		= ( ($cmd=="") ? "" : "&amp;cmd=$cmd" );
	        
	        if($section<>"" AND $section<>"news" AND $section <>"docsys" AND $section <> "shop" AND $section_var <> "gallery") {	
	             $temp_pagelink  = "?$temp_section$temp_cmd";
//	        } elseif ($section_var == "gallery" && $cmd_var == "showCat" && $pagevar == "pId=") {
//	        	$imageReso = getimagesize(ASCMS_GALLERY_PATH .'/'.$objResult->fields['content']);
//	        	$temp_pagelink = "javascript:openWindow('?section=gallery&amp;cmd=showCat&amp;cid=".$objResult->fields['catid']."&amp;pId=".$objResult->fields['id']."','','width=".($imageReso[0]+25).",height=".($imageReso[1]+25).",resizable=yes,status=no,scrollbars=yes')";
	        } else {
	        	$temp_pagelink  = "?$pagevar".$objResult->fields['id']."$temp_section$temp_cmd";
	        }
	        
	        $searchcontent = eregi_replace("\{[a-z0-9_]+\}","",strip_tags($objResult->fields['content']));
	        $searchcontent = stripslashes($searchcontent); 
	        $shortcontent = substr(ltrim($searchcontent), 0,intval($_CONFIG['searchDescriptionLength']));
	        $arrayShortContent = explode(" ",$shortcontent);
	        $arrelem= array_pop($arrayShortContent);
	        $shortcontent=str_replace("&nbsp;","",join(" ",$arrayShortContent));
	        //$shortcontent = preg_replace("'$term'i","<b><i>\\0</i></b>",$shortcontent);
	        $score=$objResult->fields['score'];
	        $score>=1 ? $scorePercent=100 : $scorePercent=intval($score*100);
	        //Muss noch gendert werden, sobald das Ranking bei News funktioniert!!!
	        $score==0 ? $scorePercent=25 : $scorePercent=$scorePercent;
	        $searchtitle=$objResult->fields['title'];
	        $arraySearchResults[$i]=array("Score"=>$scorePercent,
	                                      "Title"=>$searchtitle,
	                                      "Content"=>$shortcontent,
	                                      "Link"=>$temp_pagelink);
			$objResult->MoveNext();
	    }
    }
    return $arraySearchResults;
}

/**
* order the result-arry by matching-percent
*
* @author  	Christian Wehrli <christian.wehrli@astalavista.ch> 
* @param  	string	$a
* @param  	string	$b
* @return 	boolean	
*/
function search_comparison($a,$b)
//Fr usort(Array)
{
    if ($a==$b){
        return 0;
    }
    elseif ($a>=$b){
        return -1;
    }else{
        return 1;
    }
}
?>
