<?php
/**
* Calendar module
*
* Outputs the xhtml camedar
*
* @copyright CONTREXX CMS - Astalavista IT Engineering GmbH Thun
* @author Astalavista Development Team <thun@astalvista.ch>
* @module Calendar
* @modulegroup modules
* @access public
* @version 1.0.0
**/


class astaCalendar extends calendarLibrary
{
	var $curMonth;
	var $nextMonth;
	var $prevMonth;
	var $curYear;
	var $nextYear;
	var $prevYear;
	var $monthTitle;
	var $daysOfWeek;
	var $day;
	var $daysToCreate;
	var $eventDays;
	
	var $tableWidth;
	var $tableColor;
	var $tableBorder;
	var $tableBorderColor;
	var $tableSpacing;
	var $fontSize;
	var $fontColor;
	var $numColor;
	var $normalDayColor;
	var $normalDayRollOverColor;
	var $curDayColor;
	var $curDayRollOverColor;
	var $eventDayColor;
	var $eventDayRollOverColor;
	var $dayLink;
	var $calendarLink;
	
	var $fontStyleOne;
	var $fontStyleTwo;
	var $styleTable;
	var $borderStyleTdOne;
	var $borderStyleTdTwo;
	var $borderStyleTdThree;

	
	/**
	* PHP5 Constructor
	*
	*/	
	function astaCalendar($month, $year) {
	    $this->__construct($month, $year);	
	}
	
	
	/**
	* get welcome page
	*
	* show the welcome page
	*
	* @access	public
	* @param	object	$month
	* @param	object	$year
	*/	
	function __construct($month, $year){
		$this->curMonth     = $month;
		$this->curYear      = $year;
		$this->monthTitle   = $this->monthName($this->curMonth)." ".$this->curYear;
		$this->nextMonth    = strftime("%m", mktime(0, 0, 0, $this->curMonth + 1, 1, $this->curYear));
		$this->prevMonth    = strftime("%m", mktime(0, 0, 0, $this->curMonth - 1, 1, $this->curYear));
		$this->nextYear     = strftime("%Y", mktime(0, 0, 0, $this->curMonth + 1, 1, $this->curYear));
		$this->prevYear     = strftime("%Y", mktime(0, 0, 0, $this->curMonth - 1, 1, $this->curYear));
		$this->day          = 1 - strftime("%w", mktime(0, 0, 0, $this->curMonth, 1, $this->curYear));
		$this->daysToCreate = date("t", mktime(0, 0, 0, $this->curMonth, 1, $this->curYear));
		$this->eventDays    = array();
		
		$this->calendarCSS();
		$this->calendarTable();
	}
	
	
	// set css style
	function calendarCSS(){
		global $db;
		
		$this->daysOfWeek = array(0 => "S", 1 => "M", 2 => "T", 3 => "W", 4 => "T", 5 => "F", 6 => "S");
		
		if(isset($_GET['cmd'])){
			$id = 1;
		}
		if(isset($_GET['section'])){
			$id = 2;
		}
		
		$db->query("SELECT * FROM ".DBPREFIX."module_calendar_style WHERE id = '".$id."'");
		$db->next_record();
		
		if(eregi('p' , $db->f('tableWidth'))){
			$this->tableWidth = str_replace('p', '%', $db->f('tableWidth'));
		}else{
			$this->tableWidth = $db->f('tableWidth');
		}
		
		if(eregi('p' , $db->f('tableHeight'))){
			$this->tableHeight = str_replace('p', '%', $db->f('tableHeight'));
		}else{
			$this->tableHeight = $db->f('tableHeight');
		}
		
		$this->tableColor             = $db->f('tableColor');
		$this->tableBorder            = $db->f('tableBorder');
		$this->tableBorderColor       = $db->f('tableBorderColor');
		$this->tableSpacing           = $db->f('tableSpacing');
		$this->fontSize               = $db->f('fontSize');
		$this->fontColor              = $db->f('fontColor');
		$this->numColor               = $db->f('numColor');
		$this->normalDayColor         = $db->f('normalDayColor');
		$this->normalDayRollOverColor = $db->f('normalDayRollOverColor');
		$this->curDayColor            = $db->f('curDayColor');
		$this->curDayRollOverColor    = $db->f('curDayRollOverColor');
		$this->eventDayColor          = $db->f('eventDayColor');
		$this->eventDayRollOverColor  = $db->f('eventDayRollOverColor');
		$this->dayLink                = sprintf("class.astaCalendar.php");
	    $this->calendarLink           = sprintf("class.astaCalendar.php");
	}
	
	
	
	// write table
	function calendarTable(){
		$this->fontStyleOne  = " style='font-size:".$this->fontSize."px; text-align: center;";
		$this->fontStyleOne .= "font-weight: normal; color: ".$this->fontColor."; margin: 0px; padding: 0px;'";
		$this->fontStyleTwo  = " style='font-size:".$this->fontSize."px; ";
		$this->fontStyleTwo .= "font-weight: normal; color: ".$this->numColor."; margin: 0px; padding: 0px'";
		if($this->tableBorder > 0){
			$this->styleTable  = " style='background-color: ".$this->tableColor."; ";
			$this->styleTable .= "border-top: ".$this->tableBorder."px solid ".$this->tableBorderColor."; ";
			$this->styleTable .= "border-left: ".$this->tableBorder."px solid ".$this->tableBorderColor."; ";
			$this->styleTable .= "border-right: ".$this->tableBorder."px solid ".$this->tableBorderColor.";'";
			$this->borderStyleTdOne  = " style='border-bottom: ".$this->tableBorder."px solid ".$this->tableBorderColor."; ";
			$this->borderStyleTdOne .= "border-right: ".$this->tableBorder."px solid ".$this->tableBorderColor.";'";
			$this->borderStyleTdTwo  = " style='border-bottom: ".$this->tableBorder."px solid ".$this->tableBorderColor.";'";
			$this->borderStyleTdThree  = " style='border-bottom: ".$this->tableBorder."px solid ".$this->tableBorderColor."; ";
			$this->borderStyleTdThree .= "border-left: ".$this->tableBorder."px solid ".$this->tableBorderColor.";'";
		} else{
			$this->styleTable         = '';
			$this->borderStyleTdOne   = '';
			$this->borderStyleTdTwo   = '';
			$this->borderStyleTdThree = '';
		}
	}
	
	
	
	// put the calendar together
	function createCalendar(){
		$width = round($this->tableWidth / 7);
		$height = round($this->tableHeight / 7);
		$rows = 0;
		
		$cal  = "<table cellpadding='".$this->tableSpacing."' cellspacing='".$this->tableSpacing."' width='".$this->tableWidth;
		$cal .= "'".$this->styleTable.">\n<tr>\n";
		$cal .= "<td bgcolor='".$this->normalDayRollOverColor."' align='center'".$this->borderStyleTdOne." height='".$height."'>";
		$cal .= "<h1".$this->fontStyleOne."><a href='".$this->calendarLink."&amp;month=".$this->prevMonth."&amp;year=".$this->prevYear."' ";
		$cal .= "style='color: ".$this->fontColor.";'>&laquo;</a></h1></td>\n<td bgcolor='";
		$cal .= $this->normalDayRollOverColor."' colspan='5' align='center'";
		$cal .= $this->borderStyleTdTwo."><h1".$this->fontStyleOne."><a href='".$this->calendarLink."&amp;month=".$this->curMonth;
		$cal .= "&amp;year=".$this->curYear."' style='color: ".$this->fontColor.";'>".$this->monthTitle."</a></h1></td>\n";
		$cal .= "<td bgcolor='".$this->normalDayRollOverColor."' align='center'".$this->borderStyleTdThree.">";
		$cal .= "<h1".$this->fontStyleOne."><a href='".$this->calendarLink."&amp;month=".$this->nextMonth."&amp;year=".$this->nextYear."' ";
		$cal .= "style='color: ".$this->fontColor.";'>&raquo;</a></h1></td>\n</tr>\n<tr>\n";
		
		for($i = 0; $i < count($this->daysOfWeek); $i++){
			switch($i){
				case 5:
					$cal .= "<td bgcolor='".$this->normalDayRollOverColor."'height='".$height."' align='center'";
					$cal .= $this->borderStyleTdTwo."><h1".$this->fontStyleOne.">".$this->daysOfWeek[$i]."</h1></td>\n";
					break;
				case 6:
					$cal .= "<td bgcolor='".$this->normalDayRollOverColor."' height='".$height."' align='center'";
					$cal .= $this->borderStyleTdThree."><h1".$this->fontStyleOne.">".$this->daysOfWeek[$i]."</h1></td>\n";
					break;
				default:
					$cal .= "<td bgcolor='".$this->normalDayRollOverColor."' height='".$height."' align='center'";
					$cal .= $this->borderStyleTdOne."><h1".$this->fontStyleOne.">".$this->daysOfWeek[$i]."</h1></td>\n";
					break;
			}
		}
		$cal .= "</tr>\n";
		
		while($this->day <= $this->daysToCreate){
			$cal .= "<tr onmouseover=\"style.cursor='hand'\">\n";
			for($i = 0; $i < 7; $i++){
				switch($i){
					case 5:
						$borderStyle = $this->borderStyleTdTwo;
						break;
					case 6:
						$borderStyle = $this->borderStyleTdThree;
						break;
					default:
						$borderStyle = $this->borderStyleTdOne;
						break;
				}
				
				if(($this->day <= $this->daysToCreate) && ($this->day > 0)){
					$cal .= $this->colorDay($borderStyle, $this->day);
				} else{
					$cal .= $this->colorDay($borderStyle);
				}
				$this->day++;
				}
				
			$cal .= "</tr>\n";			
			$rows++;
			}
		
		$cal .= "</table>\n";		
		return $cal;
	}
	
	// color the days
	function colorDay($borderStyle, $day = ""){
		$height = round($this->tableHeight / 7);
		
		if(strlen($day) > 0){
			if(strlen($day) == 1){
				$day = sprintf("0%s", $day);
			}
			$dateCheck = $this->curMonth."/".$day."/".$this->curYear;
			
			if(in_array($dateCheck, $this->eventDays)){
				if(($day == date("j")) && ($this->curMonth == strftime("%m")) && ($this->curYear == strftime("%Y"))){
					$cell  = "<td align='center' bgcolor='".$this->eventDayColor."' height='".$height."' ";
					$cell .= "onmouseover=\"javascript:style.backgroundColor='".$this->eventDayRollOverColor."'\" ";
					$cell .= "onmouseout=\"javascript:style.backgroundColor='".$this->eventDayColor."'\"".$borderStyle."><h1";
					$cell .= $this->fontStyleTwo."><a href='".$this->dayLink."&amp;month=".$this->curMonth."&amp;day=".$day."&amp;year=";
					$cell .= $this->curYear."' style='color: ".$this->numColor.";' hidefocus><b style='color: #cc0000'>".$day;
					$cell .= "</b></a></h1></td>\n";
				}else{
					$cell  = "<td align='center' bgcolor='".$this->eventDayColor."' height='".$height."' ";
					$cell .= "onmouseover=\"javascript:style.backgroundColor='".$this->eventDayRollOverColor."'\" ";
					$cell .= "onmouseout=\"javascript:style.backgroundColor='".$this->eventDayColor."'\"".$borderStyle.">";
					$cell .= "<h1".$this->fontStyleTwo."><a href='".$this->dayLink."&amp;month=".$this->curMonth."&amp;day=".$day."&amp;year=";
					$cell .= $this->curYear."' style='color: ".$this->numColor.";' hidefocus>".$day."</h1></td></a>\n";
				}
			}
			else{
				if(($day == date("j")) && ($this->curMonth == strftime("%m")) && ($this->curYear == strftime("%Y"))){
					$cell  = "<td align='center' bgcolor='".$this->curDayColor."' height='".$height."' ";
					$cell .= "onmouseover=\"javascript:style.backgroundColor='".$this->curDayRollOverColor."'\" ";
					$cell .= "onmouseout=\"javascript:style.backgroundColor='".$this->curDayColor."'\"".$borderStyle."><h1";
					$cell .= $this->fontStyleTwo."><a href='".$this->dayLink."&amp;month=".$this->curMonth."&amp;day=".$day."&amp;year=";
					$cell .= $this->curYear."' style='color: ".$this->numColor.";'><b style='color: #cc0000'>".$day;
					$cell .="</b></a></h1></td>\n";
				}else{
					$cell  = "<td align='center' bgcolor='".$this->normalDayColor."' height='".$height."' ";
					$cell .= "onmouseover=\"javascript:style.backgroundColor='".$this->normalDayRollOverColor."'\" ";
					$cell .= "onmouseout=\"javascript:style.backgroundColor='".$this->normalDayColor."'\"".$borderStyle."><h1";
					$cell .= $this->fontStyleTwo."><a href='".$this->dayLink."&amp;month=".$this->curMonth."&amp;day=".$day."&amp;year=";
					$cell .= $this->curYear."' style='color: ".$this->numColor.";'>".$day."</a></h1></td>\n";
				}
			}
		}else{
			$cell = "<td align='center'".$borderStyle." height='".$height."'><h1".$this->fontStyleTwo.">&nbsp;</h1></td>\n";
		}
		
		return $cell;
	}
	
	// set days with events
	function setEventDays($events){
		$this->eventDays = $events;
	}
	
	
	// set calendar links
	function setLinks($dayLink, $calLink){
		$this->dayLink      = $dayLink;
		$this->calendarLink = $calLink;
	}
}
?>