<?PHP
/**
* Modul Gallery
*
* Class to manage the gallery of the CMS
*
* @copyright     ASTALAVISTA SECURE CMS - 2005 Astalavista IT Engineering GmbH 
* @author        Astalavista Development Team <thun@astalavista.ch>   
* @module        gallery
* @modulegroup   modules 
* @version       $Id:     Exp $    
*/

class galleryManager
{
	var $_objTpl;
	var $statusMessage = "";
	var $ArraySettings;
	var $imagePath;
	var $imageWebPath;
	var $thumbnailPath;	
	var $thumbnailWebPath;
	var $importPath;	
	var $langId;
	var $pageTitle;
	var $importFiles;
	var $gifEnabled = false;
	var $jpgEnabled = false;
	var $pngEnabled = false;
	var $maxEntries = 50;
	
	
	
	/*
	* Constructor	-> Create the menu and copy the template
    *
    * @param	obj		$objTemplate
    * @global	array	$_ARRAYLANG
    * @global	var		$db
    */ 	
	function galleryManager()
	{
		global $objDb, $_ARRAYLANG, $objTemplate, $objInit; 
		
		$this->_objTpl = &new HTML_Template_Sigma(ASCMS_MODULE_PATH.'/gallery/template');
		$this->_objTpl->setErrorHandling(PEAR_ERROR_DIE);  
    	 	
    	$this->langId=$objInit->userFrontendLangId;
    		
	    $this->imagePath = ASCMS_GALLERY_PATH . '/';
	    $this->imageWebPath = ASCMS_GALLERY_WEB_PATH . '/';	    
	    $this->thumbnailPath = ASCMS_GALLERY_THUMBNAIL_PATH . '/';		    
	    $this->thumbnailWebPath = ASCMS_GALLERY_THUMBNAIL_WEB_PATH . '/';	
	    $this->importPath = ASCMS_GALLERY_IMPORT_PATH. '/';
	    $this->importWebPath = ASCMS_GALLERY_IMPORT_WEB_PATH. '/';
		
		if (imagetypes() & IMG_GIF) {
	       $this->gifEnabled = true;
	   	}
	   	
	   	if (imagetypes() &  IMG_JPG) {
	       $this->jpgEnabled = true;
	   	}
	   	
	   	if (imagetypes() & IMG_PNG) {
	       $this->pngEnabled = true;
	   	}
	    
    	$objDb->query("SELECT name,value FROM ".DBPREFIX."module_gallery_settings");  	
    	while ($objDb->next_record()) {
    		$this->ArraySettings[$objDb->f('name')] = $objDb->f('value');	
    	}
    	$this->checkImages();		

    	$objTemplate->setVariable("CONTENT_NAVIGATION","	<a href='?cmd=gallery'>[".$_ARRAYLANG['TXT_GALLERY_MENU_OVERVIEW']."]</a>
    														<a href='?cmd=gallery&act=new_cat'>[".$_ARRAYLANG['TXT_GALLERY_MENU_NEW_CATEGORY']."]</a>
    														<a href='?cmd=gallery&act=upload_form'>[".$_ARRAYLANG['TXT_GALLERY_MENU_UPLOAD']."]</a>
    														<a href='?cmd=gallery&act=import_picture'>[Bilder Importieren]</a>
    														<a href='?cmd=gallery&act=validate_form&type=".$this->ArraySettings['validation_standard_type']."'>[".$_ARRAYLANG['TXT_GALLERY_MENU_VALIDATE']."]</a>
    														<a href='?cmd=gallery&act=settings'>[".$_ARRAYLANG['TXT_GALLERY_MENU_SETTINGS']."]</a>");
	}

	
	
    /*
	* Select the admired action
    *
    * @global	array	$_ARRAYLANG
    */ 	
    function getPage()
    {
    	global $objTemplate, $_ARRAYLANG; 
    	 
    	if(!isset($_GET['act'])) {
    	    $_GET['act']="";	
    	}    	 	
   	    switch($_GET['act']){	
			case "new_cat": 
                $this->newCategory();		
			break; 
			case "insert_category": 
                $this->insertCategory();
               $this->overview();
			break;
			case "sort_categories":
			    $this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_OVERVIEW'];
                $this->saveCategorySorting();
                $this->overview();		
			break;
			case "activate_category":
			    $this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_OVERVIEW'];
                $this->activateCategory(intval($_GET['id']));
                $this->overview();	
			break;
			case "delete_category":
			    $this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_OVERVIEW'];
                $this->deleteCategory(intval($_GET['id']));
                $this->overview();	
			break;
			case "edit_category":
			    $this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_OVERVIEW'];
                $this->editCategory(intval($_GET['id']));
			break;
			case "update_category":
			    $this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_OVERVIEW'];
                $this->updateCategory(intval($_GET['id']));
                $this->overview();	
			break;
			case "cat_details":
				$this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_CATEGORY_DETAILS'];
				$this->showCategoryDetails(intval($_GET['id']));
			break;
			case "activate_picture":
				$this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_CATEGORY_DETAILS'];
				$this->activatePicture(intval($_GET['id']));
				$this->showCategoryDetails(intval($_GET['gid']));
			break;
			case "reset_picture":
				$this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_CATEGORY_DETAILS'];
				$this->resetPicture(intval($_GET['id']));
				$this->showCategoryDetails(intval($_GET['gid']));			
			break;
			case "delete_picture":
				$this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_CATEGORY_DETAILS'];
				$this->deleteImage(intval($_GET['id']));
				$this->showCategoryDetails(intval($_GET['gid']));			
			break;
			case "change_category_picture":
				$this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_CATEGORY_DETAILS'];
				$this->changeCategoryOfPicture(intval($_GET['id']),intval($_GET['catid']));
				$this->showCategoryDetails(intval($_GET['catid']));			
			break;
			case "rotate_picture":
				$this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_CATEGORY_DETAILS'];
				$this->rotatePicture(intval($_GET['id']));
				$this->showCategoryDetails(intval($_GET['catid']));
			break;
			case "edit_picture":
				$this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_PICTURE_DETAILS'];
				$this->showEditPicture();			
			break;
			case "update_picture":
				$this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_CATEGORY_DETAILS'];
				$catId = $this->updatePicture(); //returns the groupid
				$this->showCategoryDetails($catId);
							
			break;
			case "upload_form":
			    $this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_UPLOAD_FORM']; 
                $this->showUploadForm();				
			break;
			case "upload_images":
			    $this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_UPLOAD_FORM'];
                $this->uploadImages();
			    $this->showValidateForm(); 					
			break;
			case "validate_form":
			    $this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_VALIDATE'];
			    $this->showValidateForm();
                				
			break;
			case "validate_single_picture":
			    $this->reloadSingleValidate();
			    $this->showValidateForm();					
			break;
			case "validate_all_pictures":
			    $this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_VALIDATE'];
			    $this->reloadAllValidate();
			    $this->showValidateForm();
			break;
			case "settings":
			    $this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_SETTINGS'];
                $this->showSettings();
            break;
			case "save_settings":
			    $this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_SETTINGS'];
			    $this->saveSettings();
                $this->showSettings();
			break;
			case "delete_valid_image":
				$this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_VALIDATE'];
			    $this->deleteImage(intval($_GET['id']));
			    $this->showValidateForm();
                break;
            case "import_picture":
				$this->pageTitle = $_ARRAYLANG['TXT_GALLERY_IMPORT_PICTURES'];
				$this->importPicture();			
			break;
			case "importFromFolder":
				$this->pageTitle = $_ARRAYLANG['TXT_GALLERY_IMPORT_PICTURES'];
				$this->importFromFolder();
				$this->importPicture();		
				$this->showValidateForm();	
			break;
			case "deleteImportPicture":
				$this->pageTitle = $_ARRAYLANG['TXT_GALLERY_IMPORT_PICTURES'];
				$this->deleteImportPicture();
				$this->importPicture();			
			break;
			default:
			    $this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_OVERVIEW'];
                $this->overview();              
			    break;								
		} 
		$objTemplate->setVariable(array(
			'CONTENT_TITLE'				=> $this->pageTitle,
			'CONTENT_STATUS_MESSAGE'	=> $this->statusMessage,
			'ADMIN_CONTENT'				=> $this->_objTpl->get()
		));
    }
    
    
    
    /*
	* Checks if the file is still there, removes dead links
    *
    * @global	array	$_CONFIG
    * @global	var		$db
    */ 		
	function checkImages()
	{
		global $db,$_CONFIG;
		$db->query("SELECT path, id
					FROM ".DBPREFIX."module_gallery_pictures
					WHERE validated='1'");
		while ($db->next_record())
		{
			if (!is_file($this->thumbnailPath.$db->f('path')) ||
				!is_file($this->imagePath.$db->f('path'))){
					$arrayPicToDel[$db->f('id')] = $db->f('path');	
				}
		}
		if (isset($arrayPicToDel))
		{
			foreach ($arrayPicToDel as $id => $path){
				if (is_file($this->thumbnailPath.$path)){
					@unlink($this->thumbnailPath.$path);
				}
				if (is_file($this->imagePath.$path)){
					@unlink($this->imagePath.$path);
				}
				$db->query("DELETE FROM ".DBPREFIX."module_gallery_pictures WHERE id=".$id);
			}
		}
	}  
    
    
    
    /*
	* Shows the overview of the gallery
    *
    * @global	array	$_CONFIG
    * @global	var		$db
    * @global	array	$_ARRAYLANG
    */ 	
    function overview()
    {
    	global $db, $_ARRAYLANG, $_CONFIG;

    	$this->_objTpl->loadTemplateFile('module_gallery_overview.html',true,true);
    	   
    	$this->_objTpl->setVariable(array(
    		'TXT_DELETE_CATEGORY_MSG' => $_ARRAYLANG['TXT_GALLERY_DELETE_CATEGORY_MESSAGE'],
	    	'TXT_NAME'				=>	$_ARRAYLANG['TXT_GALLERY_GALLERYNAME'],
	    	'TXT_DESC'				=>	$_ARRAYLANG['TXT_GALLERY_OVERVIEW_DESCRIPTION'],
	    	'TXT_IMAGECOUNT'		=>	$_ARRAYLANG['TXT_IMAGE_COUNT'],
	    	'TXT_SPACE'				=>	$_ARRAYLANG['TXT_REQUIRED_DISK_SPACE'],
	    	'TXT_BUTTON_SAVESORT'	=>	$_ARRAYLANG['TXT_GALLERY_BUTTON_SAVE_SORT'],
	    	'TXT_IMG_EDIT_ALT'		=>	$_ARRAYLANG['TXT_EDIT'],
	    	'TXT_IMG_DEL_ALT'		=>	$_ARRAYLANG['TXT_DELETE']
	   	));
		
	   	$db->query("SELECT id FROM ".DBPREFIX."module_gallery_categories");
	   	
	   	if ($db->num_rows() > 0){
		   	while ($db->next_record()){
		   		$arrImageSize[$db->f('id')] = '';
		   		$arrImageCount[$db->f('id')] = '';	
		   	}
		   	foreach ($arrImageSize as $key => $value){
		   		$db->query("SELECT path
		   					FROM ".DBPREFIX."module_gallery_pictures
		   					WHERE catid=".$key);
		   		
		   		$arrImageCount[$key] = $db->num_rows();
		   		while ($db->next_record()){
		   			$arrImageSize[$key] = $arrImageSize[$key] + filesize($this->imagePath.$db->f('path'));	
		   		}
		   		$arrImageSize[$key] = round($arrImageSize[$key] / 1024,2);
		   	}
	   	}
	   	
    	$db->query("SELECT id,name
    				FROM ".DBPREFIX."module_gallery_categories
    				WHERE pid=0
    				ORDER BY sorting");
    	
    	// there are no entries in the database
    	if ($db->num_rows() == 0) { 
    		$this->_objTpl->setVariable(array(
    			OVERVIEW_HIDE_S	=>	'<!--',
    			OVERVIEW_HIDE_E	=>	'-->'
    		));	
    	}
    	else
    	{ // there are entries in the database
    		while ($db->next_record()) {
    			$arrayMaincats[$db->f('id')] = $db->f('name');	
    		}
    		
    		$iRowCounter = 0;
    		
    		foreach ($arrayMaincats as $mainKey => $mainValue){
    			$db->query("SELECT description,sorting,status
    						FROM ".DBPREFIX."module_gallery_categories
    						WHERE id=".$mainKey);
    			$db->next_record();
    			$rowColor = ($iRowCounter % 2 == 0) ? 0 : 1;
    			$folderIcon = ($db->f('status') == 0) ? 'folder_off' : 'folder_on'; 
    						
    			$this->_objTpl->setVariable(array(
	    			OVERVIEW_HIDE_S			=>	'',
	    			OVERVIEW_HIDE_E			=>	'',
	    			OVERVIEW_ROWCLASS		=>	$rowColor,
	    			OVERVIEW_SUBCATEGORY	=>	'',
	    			OVERVIEW_ID				=>	$mainKey,
	    			OVERVIEW_ICON			=>	$folderIcon,
	    			OVERVIEW_SORTING		=>	$db->f('sorting'),
	    			OVERVIEW_NAME			=>	$mainValue,
	    			OVERVIEW_DESCRIPTION	=>	$db->f('description'),
			    	OVERVIEW_COUNT_IMAGES	=>	$arrImageCount[$mainKey],
			    	OVERVIEW_IMAGE_SIZE		=>	$arrImageSize[$mainKey]
    			));
    			
    			$this->_objTpl->parse('showCategories');
    			$iRowCounter++;
    			
    			$db->query("SELECT id,name,description,sorting,status
    						FROM ".DBPREFIX."module_gallery_categories
    						WHERE pid=".$mainKey."
    						ORDER BY sorting ASC");
    			
    			if ($db->num_rows() != 0)
    			{ // there are subcategories in the database
    				while ($db->next_record()){	    			
		    			$rowColor = ($iRowCounter % 2 == 0) ? 0 : 1;	    			
                        $folderIcon = ($db->f('status') == 0) ? 'folder_off' : 'folder_on'; 
		    				    			
		    			$this->_objTpl->setVariable(array(
			    			OVERVIEW_HIDE_S			=>	'',
			    			OVERVIEW_HIDE_E			=>	'',
			    			OVERVIEW_ROWCLASS		=>	$rowColor,
	    					OVERVIEW_SUBCATEGORY	=>	'&nbsp;&nbsp;&nbsp;&nbsp;',
			    			OVERVIEW_ID				=>	$db->f('id'),
			    			OVERVIEW_ICON			=>	$folderIcon,
			    			OVERVIEW_SORTING		=>	$db->f('sorting'),
			    			OVERVIEW_NAME			=>	$db->f('name'),
			    			OVERVIEW_DESCRIPTION	=>	$db->f('description'),
			    			OVERVIEW_COUNT_IMAGES	=>	$arrImageCount[$db->f('id')],
			    			OVERVIEW_IMAGE_SIZE		=>	$arrImageSize[$db->f('id')]
		    			));	
		    			$this->_objTpl->parse('showCategories');
		    			$iRowCounter++;	    				
    				}
    			}
    		}
    	} 		
    }
    
    
    
    
    /*
	* Shows the 'Insert new category'-Form
    *
    * @global	var		$db
    * @global	array	$_ARRAYLANG
    */ 	    
    function newCategory()
    {
    	global $db,$_ARRAYLANG;	
    	$this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_NEW_CATEGORY'];
    	$this->_objTpl->loadTemplateFile('module_gallery_new_category.html',true,true);
    	
    	$this->_objTpl->setVariable(array(
	    	'TXT_TITLE'	=>				$_ARRAYLANG['TXT_GALLERY_MENU_NEW_CATEGORY'],
	    	'TXT_NAME'	=>				$_ARRAYLANG['TXT_GALLERY_CATEGORY_NAME'],
	    	'TXT_CATEGORYTYPE'	=>		$_ARRAYLANG['TXT_GALLERY_CATEGORY_TYPE'],
	    	'TXT_CATEGORYTYPE_NEW'	=>	$_ARRAYLANG['TXT_GALLERY_CATEGORY_TYPE_NEW'],
	    	'TXT_CATEGORYTYPE_SUB'	=>	$_ARRAYLANG['TXT_GALLERY_CATEGORY_TYPE_SUB'],
	    	'TXT_DESCRIPTION'	=>			$_ARRAYLANG['TXT_GALLERY_CATEGORY_DESCRIPTION'],
	    	'TXT_STATUS'	=>				$_ARRAYLANG['TXT_GALLERY_CATEGORY_STATUS'],
	    	'TXT_STATUS_ON'	=>			$_ARRAYLANG['TXT_GALLERY_CATEGORY_STATUS_ON'],
	    	'TXT_STATUS_OFF'	=>			$_ARRAYLANG['TXT_GALLERY_CATEGORY_STATUS_OFF'],
	    	'TXT_BUTTON_SUBMIT'	=>		$_ARRAYLANG['TXT_GALLERY_BUTTON_NEW_CATEGORY']
    	
    	));
    	
    	$db->query("SELECT id,name 
    				FROM ".DBPREFIX."module_gallery_categories
    				WHERE pid=0
    				ORDER BY sorting ASC");
    	if ($db->num_rows() == 0)
    	{ // no rows
    		$this->_objTpl->setVariable(array(
    			NEW_CATEGORY_HIDE_S	=>	'<!--',
    			NEW_CATEGORY_HIDE_E	=>	'-->')
    		);
    	}
    	else
    	{
    		while ($db->next_record())
    		{
    			$this->_objTpl->setVariable(array(
	    			NEW_CATEGORY_HIDE_S	=>	'',
	    			NEW_CATEGORY_HIDE_E	=>	'',
	    			NEW_CATEGORY_ID	=>	$db->f('id'),
	    			NEW_CATEGORY_NAME	=>	$db->f('name')
	    		));
	    		$this->_objTpl->parse('showCategories');
    		}   		
    	}    	
    }
    
    
    /*
	* Inserts a new category into the database
    *
    * @global	var		$db
    * @global	array	$_ARRAYLANG
    */     
    function insertCategory()
    {
    	global $db,$_ARRAYLANG;
    	
    	$this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_OVERVIEW'];
    	
    	if (empty($_POST['category_name'])){
    		$_POST['category_name'] = $_ARRAYLANG['TXT_GALLERY_CATEGORY_NO_NAME'];
    	} else {
    		$_POST['category_name'] = get_magic_quotes_gpc() ? strip_tags($_POST['category_name']) : addslashes(strip_tags($_POST['category_name']));
    	}
    	if ($_POST['category_type'] == 'new'){
			$pidToInsert = 0;
    	} else{
			$pidToInsert = intval($_POST['select_category_id']);
    	}
    	
    	$_POST['category_desc'] = get_magic_quotes_gpc() ? strip_tags($_POST['category_desc']) : addslashes(strip_tags($_POST['category_desc']));
    	
    	$db->query("INSERT INTO ".DBPREFIX."module_gallery_categories
					SET name='".$_POST['category_name']."',
    					pid=".$pidToInsert.",
						description='".$_POST['category_desc']."',
						status='".intval($_POST['category_status'])."'");	
    	$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_MESSAGE_CATEGORY_INSERTED'];
    } 
    
    
    /*
	* Saves the category sorting
    *
    * @global	array	$_ARRAYLANG
    * @global	var		$db
    */ 
    function saveCategorySorting()
    {
    	global $db,$_ARRAYLANG;
    
    	foreach ($_POST as $key => $value){
    		if (substr($key,0,13) == 'sortingSystem')
    		{ // this POST-Var is sortingSystem-Var
    			$catID = substr($key,13);
   				$db->query("UPDATE ".DBPREFIX."module_gallery_categories
    						SET sorting=".intval($value)."
    						WHERE id=".intval($catID));
    		}
    	}
    	$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_STATUS_MESSAGE_SORTING_SAVED' ];
    }
    
    
    /*
	* Activates or inactivates a category
    *
    * @global	var		$db
    * @param	var		$categoryID
    */   
    function activateCategory($categoryID)
    {
    	global $db;
    	
		$db->query("SELECT status
					FROM ".DBPREFIX."module_gallery_categories
					WHERE id=".$categoryID);
		$db->next_record();
		
		if ($db->f('status') == 0){
			$newStatus = 1;	
		}else{
			$newStatus = 0;	
		}
			
		$db->query("UPDATE ".DBPREFIX."module_gallery_categories
					SET status='".$newStatus."'
					WHERE pid=".$categoryID);
    }

    
    /*
	* Delete a Category
    *
    * @global	array	$_ARRAYLANG
    * @global	var		$db
    * @global	array	$_CONFIG
    * @param	var		$categoryID
    */   
    function deleteCategory($categoryID)
    {
    	global $db,$_ARRAYLANG,$_CONFIG;
    	
    	$db->query("SELECT id
    				FROM ".DBPREFIX."module_gallery_categories
    				WHERE pid=".$categoryID);
    	while ($db->next_record())
    	{
    		$arrayCats[$db->f('id')] = $db->f('id');	
    	}
    	$arrayCats[$categoryID] = $categoryID;
    	
    	foreach ($arrayCats as $key => $value)
    	{
    		$db->query("SELECT path
	    				FROM ".DBPREFIX."module_gallery_pictures
	    				WHERE catid=".$value);
	    	while ($db->next_record()){
	    		@unlink($this->thumbnailPath.$db->f('path'));
	    		@unlink($this->imagePath.$db->f('path'));
	    	}
	    	
	    	$db->query("DELETE
	    				FROM ".DBPREFIX."module_gallery_pictures
	    				WHERE catid=".$value);
		    	
			$db->query("DELETE
						FROM ".DBPREFIX."module_gallery_categories
						WHERE id=".$value);	    	
    	}		
		$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_STATUS_MESSAGE_CATEGORY_DELETED'];
    }
    
    
    /*
	* Shows the "Edit-Category"-Form
    *
    * @global	array	$_ARRAYLANG
    * @global	var		$db
    * @param	var		$categoryID
    */   
    function editCategory($categoryID)
    {
    	global $db,$_ARRAYLANG;	

    	$this->_objTpl->loadTemplateFile('module_gallery_edit_category.html',true,true);
    	$this->_objTpl->setVariable(array(
	    	TXT_TITLE	=>				$_ARRAYLANG['TXT_GALLERY_MENU_NEW_CATEGORY'],
	    	TXT_NAME	=>				$_ARRAYLANG['TXT_GALLERY_CATEGORY_NAME'],
	    	TXT_CATEGORYTYPE	=>		$_ARRAYLANG['TXT_GALLERY_CATEGORY_TYPE'],
	    	TXT_CATEGORYTYPE_NEW	=>	$_ARRAYLANG['TXT_GALLERY_CATEGORY_TYPE_NEW'],
	    	TXT_CATEGORYTYPE_SUB	=>	$_ARRAYLANG['TXT_GALLERY_CATEGORY_TYPE_SUB'],
	    	TXT_DESCRIPTION	=>			$_ARRAYLANG['TXT_GALLERY_CATEGORY_DESCRIPTION'],
	    	TXT_STATUS	=>				$_ARRAYLANG['TXT_GALLERY_CATEGORY_STATUS'],
	    	TXT_STATUS_ON	=>			$_ARRAYLANG['TXT_GALLERY_CATEGORY_STATUS_ON'],
	    	TXT_STATUS_OFF	=>			$_ARRAYLANG['TXT_GALLERY_CATEGORY_STATUS_OFF'],
	    	TXT_BUTTON_SUBMIT	=>		$_ARRAYLANG['TXT_GALLERY_BUTTON_SAVE_CATEGORY']
    	));    	
		
    	$db->query("SELECT pid,name,description,status
    				FROM ".DBPREFIX."module_gallery_categories
    				WHERE id=".$categoryID);
    	$db->next_record();
     	
    	$this->_objTpl->setVariable(array(
    		VALUE_ID	=>	$categoryID,
    		VALUE_NAME	=>	$db->f('name'),
    		VALUE_DESC	=>	$db->f('description')
    	));
    	
    	if ($db->f('pid') == 0){
 	     	$this->_objTpl->setVariable(array(
	    		VALUE_TYPE_MAIN			=>	'checked',
	    		VALUE_TYPE_SUB			=>	'',
	    		VALUE_MAINCAT_SELECTION	=> 	'disabled'
	    	));   	   		
    	}else{
 	     	$this->_objTpl->setVariable(array(
	    		VALUE_TYPE_MAIN			=>	'',
	    		VALUE_TYPE_SUB			=>	'checked',
	    		VALUE_MAINCAT_SELECTION	=> 	''
	    	));   		
    	}
    	if ($db->f('status') == 0){
	     	$this->_objTpl->setVariable(array(
	    		VALUE_STATE_ON	=>	'',
	    		VALUE_STATE_OFF	=>	'checked'
	    	));   		
    	}else{
 			$this->_objTpl->setVariable(array(
	    		VALUE_STATE_ON	=>	'checked',
	    		VALUE_STATE_OFF	=>	''
	    	));     		
    	}
    	
    	$categoryPID = $db->f('pid');
    	$db->query("SELECT id,name 
    				FROM ".DBPREFIX."module_gallery_categories
    				WHERE pid=0
    				ORDER BY sorting ASC");
    	
    	if ($db->num_rows() == 0)
    	{ // no rows
    		$this->_objTpl->setVariable(array(
    			NEW_CATEGORY_HIDE_S	=>	'<!--',
    			NEW_CATEGORY_HIDE_E	=>	'-->')
    		);
    	}
    	else
    	{
    		while ($db->next_record())
    		{
    			if ($db->f('id') != $categoryID)
    			{
	    			$this->_objTpl->setVariable(array(
		    			NEW_CATEGORY_HIDE_S	=>	'',
		    			NEW_CATEGORY_HIDE_E	=>	'',
		    			NEW_CATEGORY_ID	=>	$db->f('id'),
		    			NEW_CATEGORY_NAME	=>	$db->f('name')
		    		));
		    		
		    		if ($db->f('id') == $categoryPID)
		    		{
		    			$this->_objTpl->setVariable("VALUE_SELECTED","selected");
		    		}
		    		else
		    		{
		    			$this->_objTpl->setVariable("VALUE_SELECTED","");
		    		}
		    		
	    			$this->_objTpl->parse('showCategories');
    			}
    		}
    	}
    }
    
    
    /*
	* Updates an category in the database
    *
    * @global	array	$_ARRAYLANG
    * @global	var		$db
    * @param	var		$categoryID
    */   
    function updateCategory($categoryID)
    {
    	global $db,$_ARRAYLANG;
    	
    	if ($_POST['category_type'] == 'main')
    	{
    		$insertPID = 0;	
    	}
    	else
    	{
    		$insertPID = intval($_POST['select_category_id']);
    	}
    	if (empty($_POST['category_name']))
    	{
    		$_POST['category_name'] = $_ARRAYLANG['TXT_GALLERY_CATEGORY_NO_NAME'];
    	} else {
    		$_POST['category_name'] = get_magic_quotes_gpc() ? strip_tags($_POST['category_name']) : addslashes(strip_tags($_POST['category_name']));
    	}
    	
    	$_POST['category_desc'] = get_magic_quotes_gpc() ? strip_tags($_POST['category_desc']) : addslashes(strip_tags($_POST['category_desc']));
    	
    	$db->query("UPDATE ".DBPREFIX."module_gallery_categories
    				SET pid=".$insertPID.",
    					name='".$_POST['category_name']."',
    					description='".$_POST['category_desc']."',
    					status='".intval($_POST['category_status'])."'
    				WHERE id=".$categoryID);
    	
    	if ($insertPID != 0)
    	{
    		$db->query("UPDATE ".DBPREFIX."module_gallery_categories
    					SET	pid=0,
    						sorting=99,
    						status='0'
    					WHERE pid=".$categoryID);
    	}
    	$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_CATEGORY_STATUS_MESSAGE_CATEGORY_UPDATED'];
    }
   
    
     
    /*
	* Shows the category-details-page
    *
    * @global	array	$_ARRAYLANG
    * @global	var		$db
    * @global	array	$_CONFIG
    */      
    function showCategoryDetails($catid)
    {
    	global $db,$_ARRAYLANG,$_CONFIG;
    	
    	$this->_objTpl->loadTemplateFile('module_gallery_category_details.html',true,true);
    	$this->_objTpl->setVariable(array(
	    	TXT_TITLE_NAME		=>	$_ARRAYLANG['TXT_GALLERY_CAT_DETAILS_NAME'],
	    	TXT_TITLE_LASTEDIT	=>	$_ARRAYLANG['TXT_GALLERY_CAT_DETAILS_LAST_EDIT'],
	    	TXT_TITLE_ORIG		=>	$_ARRAYLANG['TXT_GALLERY_CAT_DETAILS_ORIG'],
	    	TXT_TITLE_THUMB		=>	$_ARRAYLANG['TXT_GALLERY_CAT_DETAILS_THUMB'],
	    	TXT_TITLE_THUMBTYPE	=>	$_ARRAYLANG['TXT_GALLERY_CAT_DETAILS_THUMBTYPE'],
	    	TXT_TITLE_CATEGORY	=>	$_ARRAYLANG['TXT_CATEGORY'],
	    	TXT_RESET_PICTURE	=>	$_ARRAYLANG['TXT_GALLERY_CAT_DETAILS_RESET_PICTURE_MSG'],
	    	TXT_DELETE_PICTURE	=>	$_ARRAYLANG['TXT_GALLERY_DELETE_IMAGE_MSG'],
	    	TXT_IMG_ROTATE_ALT	=>	$_ARRAYLANG['TXT_GALLERY_ROTATE'],
	    	TXT_IMG_RESET_ALT	=>	$_ARRAYLANG['TXT_RESET'],
	    	TXT_IMG_EDIT_ALT	=>	$_ARRAYLANG['TXT_EDIT'],
	    	TXT_IMG_DELETE_ALT	=>	$_ARRAYLANG['TXT_DELETE']
	    ));     	
    	
    	$db->query("SELECT name FROM ".DBPREFIX."module_gallery_categories WHERE id=".$catid);
    	$db->next_record();
    	
    	$this->_objTpl->setGlobalVariable(array(
    		'CATEGORY_NAME'	=>	$db->f('name'),
    		'CATEGORY_ID'	=> $catid
    		));
    	
    	$db->query("SELECT id
    				FROM ".DBPREFIX."module_gallery_pictures
    				WHERE catid=".$catid." AND validated='1'");
    	
    	if ($db->num_rows() == 0)
    	{
    		$this->_objTpl->setVariable(array(
    			'IMAGES_HIDE_S'	=> '<!--',
    			'IMAGES_HIDE_E'	=> '-->'
    		));
    	}
    	else
    	{
			while($db->next_record()){
				$arrImages[$db->f('id')] = $db->f('id');	
			}
    		   		
    		$rowCounter = 0;
    		$this->_objTpl->setCurrentBlock("showImages");			
	    	foreach ($arrImages AS $key => $value)
	    	{
		    	$db->query("SELECT *
		    				FROM ".DBPREFIX."module_gallery_pictures
		    				WHERE id=".$value);	
		    	$db->next_record();	
	    		
	    		if ($rowCounter % 2 == 0)
	    		{
	    			$this->_objTpl->setVariable("IMAGES_ROWCLASS",0);
	    		}
	    		else
	    		{
	    			$this->_objTpl->setVariable("IMAGES_ROWCLASS",1);
	    		}
	    		
	    		if ($db->f('status') == '0')
	    		{
	    			$outputActiveIcon = 'led_red.gif';	
	    		}
	    		else
	    		{
	    			$outputActiveIcon = 'led_green.gif';	
	    		}
	    		
	    		if ( $db->f('link') == '' && $db->f('linkname') == '')
	    		{ // the linkfield is empty
	    			$outputLinkIconS = '<!--';
	    			$outputLinkIconE = '-->';
	    		}
	    		else
	    		{
	    			$outputLinkIconS = '';
	    			$outputLinkIconE = '';
	    		}
	    		
	    		$outputId = $db->f('id');
	    		
	    		$origFileInfoArray = getimagesize($this->imagePath.$db->f('path'));
	    		$thumbFileInfoArray = getimagesize($this->thumbnailPath.$db->f('path'));
	    		
	    		$outputThumbpath = $this->thumbnailWebPath.$db->f('path');
	    		$outputOrigpath = $this->imageWebPath.$db->f('path');
	    		$outputName = $db->f('name');
	    		$outputLastedit = date("d.m.Y",$db->f('lastedit'));
	    		$outputOrigReso = $origFileInfoArray[0].'x'.$origFileInfoArray[1];
	    		$outputOrigWidth = $origFileInfoArray[0]+20;
	    		$outputOrigHeight = $origFileInfoArray[1]+25;
	    		$outputOrigSize = round(filesize($this->imagePath.$db->f('path'))/1024,2);
	    		$outputThumbReso = $thumbFileInfoArray[0].'x'.$thumbFileInfoArray[1];
	    		$outputThumbSize = round(filesize($this->thumbnailPath.$db->f('path'))/1024,2);
	    		
	    		if ($db->f('size_type') == 'abs')
	    		{
	    			$outputTypeMethod = $_ARRAYLANG['TXT_GALLERY_VALIDATE_THUMB_SIZE_ABS'];
	    			$outputTypeSize = $_ARRAYLANG['TXT_QUALITY'].":".$db->f('quality').'%';
	    		}
	    		else
	    		{
	    			$outputTypeMethod = $_ARRAYLANG['TXT_GALLERY_VALIDATE_THUMB_SIZE_PER']."&nbsp;:".$db->f('size_proz');
	    			$outputTypeSize = $_ARRAYLANG['TXT_QUALITY'].":".$db->f('quality').'%';
	    		}
	    		
	    		$outputSelect = '	<select name="newCategory'.$db->f('id').'" 
	    							onchange="window.location= this.options[this.selectedIndex].value">';
	    		$outputSelect .= '<option value="0">---------------------------</option>';
				//here starts the category-menu
				$db->query("SELECT id,name
							FROM ".DBPREFIX."module_gallery_categories
							WHERE pid=0 AND status='1'
							ORDER BY sorting");
				while ($db->next_record())
				{
					$arrayMainCategories[$db->f('id')] = $db->f('name');	
				}
				foreach ($arrayMainCategories as $mainCatKey => $mainCatValue)
				{
					$outputSelect .= '<option value="?cmd=gallery&act=change_category_picture&id='.$outputId.'&catid='.$mainCatKey.'">'.$mainCatValue.'</option>';
					$db->query("SELECT id,name
								FROM ".DBPREFIX."module_gallery_categories
								WHERE pid=".$mainCatKey." AND status='1'
								ORDER BY sorting");
					
					if ($db->num_rows() > 0)
					{
						while ($db->next_record())
						{
							$outputSelect .= '<option value="?cmd=gallery&act=change_category_picture&id='.$outputId.'&catid='.$db->f('id').'">&nbsp;&nbsp;&nbsp;'.$db->f('name').'</option>';			
						}		
					}
				}
				// here ends the category-menu	    		
	    		$outputSelect .= '</select>';
	    		
	 			$this->_objTpl->setVariable(array(
	    			IMAGES_HIDE_S			=> '',
	    			IMAGES_HIDE_E			=> '',
	    			IMAGES_ID				=>	$outputId,
	    			IMAGES_THUMB_PATH		=>	$outputThumbpath,
	    			IMAGE_ORIG_PATH			=>	$outputOrigpath,
	    			IMAGES_ACTIVE_ICON		=>	$outputActiveIcon,
	    			IMAGES_HIDE_LINKICON_S	=>	$outputLinkIconS,
	    			IMAGES_HIDE_LINKICON_E	=>	$outputLinkIconE,
	    			IMAGES_NAME				=>	$outputName,
	    			IMAGES_LASTEDIT			=>	$outputLastedit,
	    			IMAGES_ORIG_RESO		=>	$outputOrigReso,
	    			IMAGES_ORIG_WIDTH		=>	$outputOrigWidth,
	    			IMAGES_ORIG_HEIGHT		=>	$outputOrigHeight,
	    			IMAGES_ORIG_SIZE		=>	$outputOrigSize,
	    			IMAGES_THUMB_RESO		=>	$outputThumbReso,
	    			IMAGES_THUMB_SIZE		=>	$outputThumbSize,
	    			IMAGES_TYPE_METHOD		=>	$outputTypeMethod,
	    			IMAGES_TYPE_SIZE		=>	$outputTypeSize,
	    			IMAGES_CATEGORY_SELECT	=>	$outputSelect
	    		));	
    		
	    		$this->_objTpl->parseCurrentBlock();
	    		$rowCounter++;
	    	}	    	
    	}
    }
    
    
    
    /*
	* Activate / Inactivate a picture
    *
    * @global	var		$db
    * @param	var		$imageId
    */           
    function activatePicture($imageId)
    {
    	global $db;
    	
    	$db->query("SELECT status
    				FROM ".DBPREFIX."module_gallery_pictures
    				WHERE id=".$imageId);
    	$db->next_record();
    	
    	if ($db->f('status') == '0')
    	{
    		$newState = 1;	
    	}
    	else
    	{
    		$newState = 0;	
    	}
    	
    	$db->query("UPDATE ".DBPREFIX."module_gallery_pictures
    				SET status='".$newState."'
    				WHERE id=".$imageId);
    }
    
    
    /*
	* Reset the picture and put it back to the validation part
    *
    * @global	var		$db
    * @global	array	$_CONFIG
    * @global	array	$_ARRAYLANG
    * @param	var		$imageId
    */ 
    function resetPicture($imageId)
    {
    	global $db,$_CONFIG,$_ARRAYLANG;
    	
    	$db->query("SELECT path
    				FROM ".DBPREFIX."module_gallery_pictures
    				WHERE id=".$imageId);
    	$db->next_record();
    
    	unlink($this->thumbnailPath.$db->f('path'));
    	
    	$db->query("UPDATE ".DBPREFIX."module_gallery_pictures
    				SET validated='0',
    					lastedit=".time().",
    					catid=0
    				WHERE id=".$imageId);
    	
    	$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_STATUS_MESSAGE_PICTURE_RESET'];
    }
    
    
    
    /*
	* Changes the Category of an Image
    *
    * @global	var		$db
    * @global	array	$_ARRAYLANG
    * @param	var		$imageId
    * @param	var		$newCatid
    */     
    function changeCategoryOfPicture($imageId,$newCatId)
    {
    	global $db,$_ARRAYLANG;
       	
    	$db->query("UPDATE ".DBPREFIX."module_gallery_pictures
    				SET catid=".$newCatId.",
    					lastedit=".time()."
    				WHERE id=".$imageId);
    	
    	$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_STATUS_MESSAGE_PICTURE_CATEGORY_CHANGED'];
    }
    
    
    
    /*
	* Shows the edit-form for a picture
    *
    * @global	var		$db
    * @global	array	$_CONFIG
    * @global	array	$_ARRAYLANG
    */      
    function showEditPicture()
    {
    	global $db,$_ARRAYLANG,$_CONFIG;

    	$this->_objTpl->loadTemplateFile('module_gallery_edit_image.html',true,true);
    	$this->_objTpl->setVariable(array(
    		'TXT_TITLE'			=>	$_ARRAYLANG['TXT_GALLERY_MENU_PICTURE_DETAILS'],
    		'TXT_IMAGENAME'		=>	$_ARRAYLANG['TXT_IMAGE_NAME'],
    		'TXT_IMAGELINKNAME'	=>	$_ARRAYLANG['TXT_IMAGE_LINK_NAME'],
    		'TXT_LINKNAME_HELP'	=>	$_ARRAYLANG['TXT_IMAGE_LINK_HELP'],
    		'TXT_IMAGELINK'		=>	$_ARRAYLANG['TXT_IMAGE_LINK'],
    		'TXT_SIZESHOW'		=>	$_ARRAYLANG['TXT_IMAGE_SIZE_SHOW'],
    		'TXT_BUTTON_SUBMIT'	=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_BUTTON_SUBMIT'],
    	));
    	
    	$db->query("SELECT path,name,link,linkname,size_show
    				FROM ".DBPREFIX."module_gallery_pictures
    				WHERE id=".intval($_GET['id']));
    	
    	$db->next_record();
    	$sizeShow = ($db->f('size_show') == '1') ? "checked" : "";
    	
    	$this->_objTpl->setVariable(array(
    		'VALUE_THUMB_PATH' => $this->thumbnailWebPath.$db->f('path'),
    		'VALUE_NAME'=> $db->f('name'),
    		'VALUE_LINKNAME'=> $db->f('linkname'),
    		'VALUE_LINK'=> $db->f('link'),
    		'VALUE_SIZESHOW_CHECKED'=> $sizeShow,
    		'VALUE_ID'=> intval($_GET['id'])  	
    	));
    }
    
    
    /*
	* Updates the name of a picture
	*
    * @global	var		$db
    * @global	array	$_ARRAYLANG
    * @global	var		$imageId
    */ 
    function updatePicture()
    {
    	global $db,$_ARRAYLANG,$_CONFIG;
    	
    	if (!isset($_POST['pictureName']) || empty($_POST['pictureName'])){
    		$_POST['pictureName'] = $_ARRAYLANG['TXT_GALLERY_CATEGORY_NO_NAME'];
    	} else {
    		$_POST['pictureName'] = get_magic_quotes_gpc() ? strip_tags($_POST['pictureName']) : addslashes(strip_tags($_POST['pictureName']));
    	}
    	
    	$_POST['pictureLinkName'] = get_magic_quotes_gpc() ? strip_tags($_POST['pictureLinkName']) : addslashes(strip_tags($_POST['pictureLinkName']));
    	$_POST['pictureLink'] = get_magic_quotes_gpc() ? strip_tags($_POST['pictureLink']) : addslashes(strip_tags($_POST['pictureLink']));
    	
    	$sizeShow = isset($_POST['pictureSizeShow']) ? 1 : 0;    	 	
    	$db->query("UPDATE ".DBPREFIX."module_gallery_pictures
    				   SET name='".$_POST['pictureName']."',
    					   linkname='".$_POST['pictureLinkName']."',
    					   link='".$_POST['pictureLink']."',
    					   size_show='".$sizeShow."',
    					   lastedit=".time()."
    				 WHERE id=".intval($_GET['id']));
    	
    	$db->query("SELECT catid
    				  FROM ".DBPREFIX."module_gallery_pictures
    				 WHERE id=".intval($_GET['id']));
    	$db->next_record();    	   	
    	return $db->f('catid');
    }
    
    
    /*
	* Shows the settings-page
    *
    * @global	array	$_ARRAYLANG
    * @global	var		$db
    */       
    function showSettings()
    {
     	global $db,$_ARRAYLANG;
     	
     	$this->_objTpl->loadTemplateFile('module_gallery_settings.html',true,true);  	
    	$this->_objTpl->setVariable(array(
	    	'TXT_TITLE'			=>	$_ARRAYLANG['TXT_GALLERY_MENU_SETTINGS'],
	    	'TXT_BUTTON_SUBMIT'	=>	$_ARRAYLANG['TXT_GALLERY_BUTTON_SAVE_SETTINGS']
    	)); 

    	$db->query("SELECT *
    				FROM ".DBPREFIX."module_gallery_settings
    				ORDER BY id"
    				);
    	
    	$this->_objTpl->setCurrentBlock("showSettings");
    	$iRowCounter = 0;   	
    	while ($db->next_record())
    	{
    		$this->_objTpl->setVariable(array(
    			SETTINGS_NAME	=>	$db->f('name'),
    			SETTINGS_VALUE	=>	$db->f('value'),
    			SETTINGS_DESC	=>	$_ARRAYLANG[$db->f('description')]    			
    		));
    		
    		if ($iRowCounter % 2 == 0)
    		{
    			$this->_objTpl->setVariable("SETTINGS_ROWCLASS",2);	
    		}
    		else
    		{
    			$this->_objTpl->setVariable("SETTINGS_ROWCLASS",1);	
    		}   		
    		$this->_objTpl->parseCurrentBlock();   		
    		$iRowCounter++;
    	}	
    } 
    
      
    /*
	* Save the settings for the gallery
    *
    * @global	array	$_ARRAYLANG
    * @global	var		$db
    * @global	array	$_POST
    */     
    function saveSettings()
    {
    	global $db,$_ARRAYLANG;
    	
    	if ($_POST['standard_size_type'] != 'proz' && $_POST['standard_size_type'] != 'abs')
    	{ // the submitted category isnt allowed, so set the standardvalue 'proz'
    		$_POST['standard_size_type'] = 'proz';	
    	}    	
    	if ($_POST['standard_height_abs'] > 0 && $_POST['standard_width_abs'] > 0)
    	{ // only one value can be bigger than 0, so set one to zero
    		$_POST['standard_height_abs'] = 0;	
    	}   	
    	if ($_POST['standard_height_abs'] > 2000)
    	{
    		$_POST['standard_height_abs'] = 2000;	
    	}
    	if ($_POST['standard_width_abs'] > 2000)
    	{
    		$_POST['standard_width_abs'] = 2000;	
    	}
    	if ($_POST['validation_standard_type'] != 'all' && $_POST['validation_standard_type'] != 'single')
    	{ // the submitted standard type is not correct
    		$_POST['validation_standard_type'] = 'all';
    	}
    	if ($_POST['show_names'] != 'on' && $_POST['show_names'] != 'off')
    	{ // the value is not allowed, reset to off
    		$_POST['show_names'] = 'off';
    	}
		foreach ($_POST as $key => $value)
		{
			$db->query("UPDATE ".DBPREFIX."module_gallery_settings
						SET value='".$value."'
						WHERE name='".$key."'");	
		}
		$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_STATUS_MESSAGE_SETTINGS_SAVED'];
    }
    
    
    /*
	* Shows the UploadForm
    *
    * @global	array	$_ARRAYLANG
    * @global	var		$db
    */     
    function showUploadForm()
    {
    	global $db,$_ARRAYLANG;
    	
    	//get enabled filetypes
		if($this->gifEnabled == true){
			$enabledTypes .= "GIF ";
		}
		
		if($this->jpgEnabled == true){
			$enabledTypes .= "JPG ";
		}
		
		if($this->pngEnabled == true){
			$enabledTypes .= "PNG ";
		}
    	
    	$this->_objTpl->loadTemplateFile('module_gallery_upload_images.html',true,true); 
 		$this->_objTpl->setVariable(array(
			'TXT_TITLE'			=>	$_ARRAYLANG['TXT_GALLERY_MENU_UPLOAD_FORM'],
			'TXT_IMAGENUMBER'		=>	$_ARRAYLANG['TXT_GALLERY_UPLOAD_FORM_IMAGE_NUMBER'],
			'TXT_ENABLED_IMAGE_TYPE'		=>	$_ARRAYLANG['TXT_GALLERY_FORMAT_SUPPORT']." ".$enabledTypes.". ".$_ARRAYLANG['TXT_GALLERY_NO_UPLOAD'],
			'TXT_BUTTON_SUBMIT'	=>	$_ARRAYLANG['TXT_GALLERY_MENU_UPLOAD_FORM_SUBMIT']		
		));
		
		$this->_objTpl->setCurrentBlock("showUploadForm");
		$iRowCounter = 0;
		for ($i = 1; $i <= $this->ArraySettings['max_images_upload'];$i++)
		{
    		if ($iRowCounter % 2 == 0)
    		{
    			$this->_objTpl->setVariable("UPLOAD_ROWCLASS",2);	
    		}
    		else
    		{
    			$this->_objTpl->setVariable("UPLOAD_ROWCLASS",1);	
    		}
			$this->_objTpl->setVariable("UPLOAD_IMAGENUMBER",$i);
			$this->_objTpl->parseCurrentBlock();
			$iRowCounter++;
		}
    }
    
    
    
    /*
	* Upload the submitted images
    *
    * @global	array	$_CONFIG
    * @global	array	$_ARRAYLANG
    * @global	var		$db
    * @global 	array	$_FILES
    */      
    function uploadImages(){
    	global $db,$_ARRAYLANG,$_FILES,$_CONFIG;
    	
    	$uploadedImagesCounter = 0;
		for ($i = 1; $i <= $this->ArraySettings['max_images_upload'];$i++){		
			$uploadedImage_name = strcheck($_FILES['imageFile'.$i]['name']);
			$uploadedImage_type	= $_FILES['imageFile'.$i]['type'];
			$uploadedImage_size	= $_FILES['imageFile'.$i]['size'];
			$uploadedImage_tempname	= $_FILES['imageFile'.$i]['tmp_name'];
			$uploadedImage_error = $_FILES['imageFile'.$i]['error'];

			$enabledTypes = array();

			if($this->gifEnabled == true){
				$enabledTypes[] = "image/gif";
			}
			
			if($this->jpgEnabled == true){
				$enabledTypes[] = "image/pjpeg";
				$enabledTypes[] = "image/jpeg";
			}
			
			if($this->pngEnabled == true){
				$enabledTypes[] = "image/png";
			}
			
			//&& $uploadedImage_type == "image/pjpeg" || $uploadedImage_type == "image/jpeg" || $uploadedImage_type == "image/x-png"
						
			
			if ($uploadedImage_error == 0 ){ // no errors reported and the file type is okay
				if(in_array($uploadedImage_type, $enabledTypes)){
					if (file_exists($this->imagePath.$uploadedImage_name)) { //This filename already exists --> add a number behind the file (1,2,3...)					
						$tmpFileEnding = strrchr($uploadedImage_name,"."); // i have the fileending
						
						$tmpFileName = '';
						$tmpFileArray = explode(".",$uploadedImage_name);
						for ($j = 0;$j < count($tmpFileArray)-1;$j++){
							$tmpFileName .= $tmpFileArray[$j].".";
						}
						$tmpFileName = substr($tmpFileName,0,strlen($tmpFileName)-1); // i have the filename
	
						$checker = false;
						$j=1;
						while ($checker == false){
							if (!file_exists($this->imagePath.$tmpFileName.$j.$tmpFileEnding)){ //The filename is okay
								$uploadedImage_name = $tmpFileName.$j.$tmpFileEnding;
								$checker = true;
							}
							$j++;
						}
					}		
					$UploadPath = $this->imagePath.$uploadedImage_name;			
					$DatabasePath = $uploadedImage_name;
									
					move_uploaded_file($uploadedImage_tempname,$UploadPath);
					// echo "DatabasePath $DatabasePath<br>";
					// echo "uploadedImage_name : $uploadedImage_name";
					$this->insertImage($DatabasePath,$uploadedImage_name);
					$uploadedImagesCounter++;
				}
			}
		}
		$this->statusMessage = $uploadedImagesCounter." ".$_ARRAYLANG['TXT_GALLERY_STATUS_MESSAGE_IMAGES_UPLOADED'];
    }
    
    
    /*
	* Insert image into the database
    *
    * @param	var		$imagePath
    * @param	var		$imageName
    * @global	array	$_CONFIG
    * @global	var		$db
    * @global	array	$ArraySettings
    */ 
    function insertImage($imagePath,$imageName){
    	global $db,$_CONFIG;
    	
    	$arrImageInfo = getimagesize($this->imagePath.$imagePath);
    	$oldWidth = $arrImageInfo[0];
    	$oldHeight = $arrImageInfo[1];
    	$insertWidth = intval($this->ArraySettings['standard_width_abs']);
    	$insertHeight = intval($this->ArraySettings['standard_height_abs']);
    	   	
    	if ($insertWidth == 0){
    		// exception if width and height or 0!
    		if($insertHeight == 0){
    			$this->ArraySettings['standard_height_abs'] = 100;
    			$insertHeight = intval($this->ArraySettings['standard_height_abs']);
    			$insertWidth = round(($oldWidth * $insertHeight) / $oldHeight,0);
    		} else {
    			$insertWidth = round(($oldWidth * $insertHeight) / $oldHeight,0);
    		}
    	} else {
    		$insertHeight = round(($oldHeight * $insertWidth) / $oldWidth,0);
    	}
    	
    	$db->query("INSERT INTO ".DBPREFIX."module_gallery_pictures
    				SET name='".$imageName."',
    					path='".$imagePath."',
    					lastedit=".time().",
    					quality=".$this->ArraySettings['standard_quality'].",
    					size_type='".$this->ArraySettings['standard_size_type']."',
    					size_proz=".$this->ArraySettings['standard_size_proz'].",
    					size_abs_h=".$insertHeight.",
    					size_abs_w=".$insertWidth);
    }
    
    
    /*
	* Shows the validation-page
    *
    * @global	array	$_ARRAYLANG
    * @global	array	$_CONFIG
    * @global	var		$db
    * @global	var		$_GET['type']
    */
    function showValidateForm()
    {
    	global $_ARRAYLANG,$db,$_CONFIG;
    	
    	$this->_objTpl->loadTemplateFile('module_gallery_validate_main.html',true,true); 
 		$this->_objTpl->setVariable(array(
			'TXT_TITLE'	=> $_ARRAYLANG['TXT_GALLERY_MENU_VALIDATE'],
			'TXT_NOTVALIDATED'	=> $_ARRAYLANG['TXT_GALLERY_VALIDATE_NOT_VALIDATED'],
			'TXT_VALIDATE_METHOD_SINGLE' =>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_METHOD_SINGLE'],
			'TXT_VALIDATE_METHOD_ALL' => $_ARRAYLANG['TXT_GALLERY_VALIDATE_METHOD_ALL'],
		));
		
		if (!isset($_GET['type'])) {			
			$_GET['type'] = $this->ArraySettings['validation_standard_type'];	
		}
		
		switch ($_GET['type'])
		{
			case "all":
				$this->_objTpl->setVariable(array(
					VALIDATE_METHOD_SINGLE_SELECTED	=> '',
					VALIDATE_METHOD_ALL_SELECTED	=>	'checked'
				));
			break;
			default:
				$this->_objTpl->setVariable(array(
					VALIDATE_METHOD_SINGLE_SELECTED	=> 'checked',
					VALIDATE_METHOD_ALL_SELECTED	=>	''
				));
		}
		
		$db->query("SELECT id
					FROM ".DBPREFIX."module_gallery_pictures
					WHERE validated='0'");
		
		$this->_objTpl->setVariable("VALIDATE_NOTVALIDATEDPICS",$db->num_rows());
		
		if ($db->num_rows() > 0) {
            // only a single picture			
			if ($_GET['type'] == 'single') {
		 		$this->_objTpl->loadTemplateFile('module_gallery_validate_details_single.html',true,true); 
				$this->_objTpl->setVariable(array(
					'TXT_DETAILS_TITLE'				=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_PICTURE_DETAILS'],
					'TXT_DETAILS_NAME'				=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_NAME'],
					'TXT_DETAILS_UPLOADDATE'			=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_UPLOAD_DATE'],
					'TXT_DETAILS_CATEGORY'			=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_CATEGORY'],
					'TXT_DETAILS_CATEGORYSELECT'		=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_CATEGORY_SELECT'],
					'TXT_DETAILS_ACTIVE'				=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_ACTIVE'],
					'TXT_DETAILS_SIZE_ORIG'			=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_SIZE_ORG'],

					'TXT_DETAILS_HEIGHT_WIDTH_ORIG'	=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_HEIGHT_WIDTH_ORIG'],
					'TXT_DETAILS_SIZE_THUMB'			=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_SIZE_THUMB'],
					'TXT_DETAILS_HEIGHT_WIDTH_THUMB'	=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_HEIGHT_WIDTH_THUMB'],
					'TXT_DETAILS_NEW_SIZE_THUMB'		=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_THUMB_SIZE'],
					'TXT_DETAILS_NEW_QUALITY_THUMB'	=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_THUMB_QUALITY'],
					'TXT_DETAILS_THUMB_SIZE_ABS'	=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_THUMB_SIZE_ABS'],
					'TXT_DETAILS_THUMB_SIZE_PROZ'		=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_THUMB_SIZE_PER'],
					'TXT_DETAILS_THUMB_SIZE_ABS_WIDTH'	=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_THUMB_SIZE_ABS_WIDTH'],
					'TXT_DETAILS_THUMB_SIZE_ABS_HEIGHT'	=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_THUMB_SIZE_ABS_HEIGHT'],
					'TXT_DETAILS_THUMB_PREVIEW'	=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_THUMB_PREVIEW'],
					'TXT_DETAILS_BUTTON_UPDATE'	=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_BUTTON_UPDATE'],
					'TXT_DETAILS_BUTTON_SUBMIT'	=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_BUTTON_SUBMIT'],
					'TXT_DETAILS_BUTTON_DELETE'	=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_BUTTON_DELETE']
				));			
			
				$db->query("SELECT *
							FROM ".DBPREFIX."module_gallery_pictures
							WHERE validated='0'
							ORDER BY lastedit ASC");
				$db->next_record();
				$detailsActive = ($db->f('status') == '1') ? "checked" : "";
			
				$imageCatid = $db->f('catid');
				$arrImageInfos = getimagesize($this->imagePath.$db->f('path'));
			
				$this->_objTpl->setCurrentBlock("showThumbSize");
				for ($i = 5; $i <= 100; $i=$i+5) {
					$this->_objTpl->setVariable("THUMB_SIZE_VALUE",$i);
					if ($i >= $db->f('size_proz') && !$checkerThumbFileSize) {
						$this->_objTpl->setVariable("THUMB_SIZE_SELECTED","selected");
						$checkerThumbFileSize = true;
					} else{
						$this->_objTpl->setVariable("THUMB_SIZE_SELECTED","");
					}
					$this->_objTpl->parseCurrentBlock();
				}
			
				$this->_objTpl->setCurrentBlock("showThumbQuality");
				for ($i = 5; $i <= 100; $i=$i+5)
				{
					$this->_objTpl->setVariable("THUMB_QUALITY_VALUE",$i);
					if ($i >= $db->f('quality') && !$checkerThumbFileQuality){
						$this->_objTpl->setVariable("THUMB_QUALITY_SELECTED","selected");
						$checkerThumbFileQuality = true;
					} else{
						$this->_objTpl->setVariable("THUMB_QUALITY_SELECTED","");
					}
					$this->_objTpl->parseCurrentBlock();				
				}
				
				//create a thumbnail, but first delete all temporary files!
				$dirHandle =opendir($this->thumbnailPath); 
				while ($dirFile = readdir ($dirHandle)) { 
				    if (substr($dirFile,0,5) == 'temp_') {
				        unlink($this->thumbnailPath.$dirFile);
				    } 
				}
				closedir($dirHandle); 

				srand ((double)microtime()*1000000);
				$newThumbnailRandomValue = rand(); // create a random value for the picture
				
				$this->_objTpl->setVariable(array(
						'DETAILS_SIZE_ABS_WIDTH_VALUE'	=>	$db->f('size_abs_w'),
						'DETAILS_SIZE_ABS_HEIGHT_VALUE'	=>	$db->f('size_abs_h'),
						));
								
				if ($db->f('size_type') == 'proz')
				{ // the image sizes are proportional
					$this->_objTpl->setVariable(array(
						'DETAILS_SIZE_SELECTION_PROZ'	=>	'checked',
						'DETAILS_SIZE_SELECTION_ABS'	=>	'',
						'DETAILS_SIZE_ABS_WIDTH_DISABLED'	=>	'disabled',
						'DETAILS_SIZE_ABS_HEIGHT_DISABLED'	=>	'disabled',
						'DETAILS_SIZE_ABS_PROP_DISABLED'	=>	'disabled',
						'DETAILS_SIZE_PROZ_WIDTH_DISABLED'	=>	'',
					));
					
					echo $db->f('size_proz')/100 * $arrImageInfos[0];
					echo $db->f('size_proz')/100 * $arrImageInfos[1];
					
					$newThumbnailWidth = floor(($db->f('size_proz')/100) * $arrImageInfos[0]);
					$newThumbnailHeight = floor(($db->f('size_proz')/100) * $arrImageInfos[1]);
					$newThumbnailQuality = $db->f('quality');
				}
				else
				{
					$this->_objTpl->setVariable(array(
						DETAILS_SIZE_SELECTION_PROZ	=>	'',
						DETAILS_SIZE_SELECTION_ABS	=>	'checked',
						DETAILS_SIZE_ABS_WIDTH_DISABLED	=>	'',
						DETAILS_SIZE_ABS_HEIGHT_DISABLED	=>	'',
						DETAILS_SIZE_PROZ_WIDTH_DISABLED	=>	'disabled',
						DETAILS_SIZE_ABS_PROP_DISABLED	=>	''
	
					));
									
					$newThumbnailWidth = $db->f('size_abs_w');
					$newThumbnailHeight = $db->f('size_abs_h');
					$newThumbnailQuality = $db->f('quality');
				}	
				
				//create thumb
				$this->createImages_JPG_GIF_PNG($this->imagePath, $this->thumbnailPath, $db->f('path'), "temp_".$newThumbnailRandomValue."_".$db->f('path'), $newThumbnailWidth, $newThumbnailHeight, $newThumbnailQuality);	
				
				$this->_objTpl->setVariable(array(
					DETAILS_ID			=> $db->f('id'),
					DETAILS_NAME		=>	$db->f('name'),
					DETAILS_UPLOADDATE	=>	date("d.m.Y - h:i:s",$db->f('lastedit')),
					DETAILS_ACTIVE_SELECTED	=>	$detailsActive,
					DETAILS_SIZE_ORIG	=>	round(filesize($this->imagePath.$db->f('path'))/1024,2),
					DETAILS_SIZE_THUMB	=>	round(filesize($this->thumbnailPath."temp_".$newThumbnailRandomValue."_".$db->f('path'))/1024,2),
					DETAILS_WIDTH_ORIG	=>	$arrImageInfos[0],
					DETAILS_HEIGHT_ORIG	=>	$arrImageInfos[1],
					DETAILS_WIDTH_THUMB	=>	$newThumbnailWidth,
					DETAILS_HEIGHT_THUMB	=>	$newThumbnailHeight,
					DETAILS_THUMB_PREVIEW_PATH	=>	$this->thumbnailWebPath."temp_".$newThumbnailRandomValue."_".$db->f('path')
				));
			
				//here starts the category-menu
				$db->query("SELECT id,name
							FROM ".DBPREFIX."module_gallery_categories
							WHERE pid=0 AND status='1'
							ORDER BY sorting");
				if ($db->num_rows() > 0) {
					while ($db->next_record()){
						$arrayMainCategories[$db->f('id')] = $db->f('name');	
					}					
					
					foreach ($arrayMainCategories as $mainCatKey => $mainCatValue){
						if ($imageCatid == $mainCatKey){
							$catSelected = 'selected';	
						} else {
							$catSelected = '';	
						}
						
						$this->_objTpl->setVariable(array(
							'CATEGORY_ID' => $mainCatKey,
							'CATEGORY_NAME' => $mainCatValue,
							'CATEGORY_SPACER' => "",
							'CATEGORY_SELECTED'	=> $catSelected
						));
						$this->_objTpl->parse('showCategories');
						
						$db->query("SELECT id,name
									FROM ".DBPREFIX."module_gallery_categories
									WHERE pid=".$mainCatKey." AND status='1'
									ORDER BY sorting");
						if ($db->num_rows() > 0)
						{
							while ($db->next_record())
							{					
								if ($imageCatid == $db->f('id'))
								{
									$catSelected = 'selected';	
								}
								else
								{
									$catSelected = '';	
								}
								$this->_objTpl->setVariable(array(
									CATEGORY_ID			=>	$db->f('id'),
									CATEGORY_NAME		=>	$db->f('name'),
									CATEGORY_SPACER		=>	"&nbsp;&nbsp;&nbsp;",
									CATEGORY_SELECTED	=>	$catSelected
								));
								$this->_objTpl->parse('showCategories');
							}		
						}
					}
				}
				else
				{
					$this->_objTpl->setVariable(array(
						CATEGORY_ID			=>	0,
						CATEGORY_NAME		=>	'',
						CATEGORY_SPACER		=>	'',
						CATEGORY_SELECTED	=>	''
					));	
				}
				// here ends the category-menu		
				$this->_objTpl->parse('showCategories');
			}
			else // multiple pictures on one page
			{ 
				$this->_objTpl->loadTemplateFile('module_gallery_validate_details_all.html',true,true); 
				$this->_objTpl->setVariable(array(
					'TXT_TITLE_NAME'					=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_NAME'],
					'TXT_TITLE_UPLOADDATE'			=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_UPLOAD_DATE'],
					'TXT_TITLE_SIZE_O'				=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_SIZE_ORG'],
					'TXT_TITLE_RESO_O'				=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_HEIGHT_WIDTH_ORIG'],
					'TXT_TITLE_SIZE_T'				=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_SIZE_THUMB'],
					'TXT_TITLE_RESO_T'				=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_HEIGHT_WIDTH_THUMB'],
					'TXT_TITLE_CATEGORY'				=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_CATEGORY'],
					'TXT_TITLE_ACTIVE'				=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_ACTIVE'],
					'TXT_DELETE_IMAGE_MSG'			=>	$_ARRAYLANG['TXT_GALLERY_DELETE_IMAGE_MSG'],
					'TXT_WRONG_CATEGORIES_MSG'		=>	$_ARRAYLANG['TXT_GALLERY_WRONG_CATEGORIES_MSG'],
					'TXT_SETTINGS_FILENAME'			=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_ALL_SET_FILENAME'],
					'TXT_SETTINGS_TITLE'				=>	$_ARRAYLANG['TXT_SETTINGS'],
					'TXT_SETTINGS_ACTIVE'				=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_ALL_SET_ACTIVE'],
					'TXT_SETTINGS_CATEGORY'			=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_ALL_SET_CATEGORY'],
					'TXT_SETTINGS_THUMBSIZE_ABS'		=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_THUMB_SIZE_ABS'],
					'TXT_SETTINGS_THUMBSIZE_PROZ'		=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_THUMB_SIZE_PER'],
					'TXT_SETTINGS_TITLE_THUMBSIZE'	=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_THUMB_SIZE'],
					'TXT_SETTINGS_THUMBSIZE_ABS_WIDTH'	=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_THUMB_SIZE_ABS_WIDTH'],
					'TXT_SETTINGS_THUMBSIZE_ABS_HEIGHT'	=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_THUMB_SIZE_ABS_HEIGHT'],
					'TXT_SETTINGS_TITLE_THUMBQUALITY'		=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_THUMB_QUALITY'],
					'TXT_DETAILS_BUTTON_UPDATE'	=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_BUTTON_UPDATE'],
					'TXT_DETAILS_BUTTON_SUBMIT'	=>	$_ARRAYLANG['TXT_GALLERY_VALIDATE_BUTTON_SUBMIT'],
				));
				
				$this->_objTpl->setGlobalVariable('TXT_DETAILS_CATEGORYSELECT', $_ARRAYLANG['TXT_GALLERY_VALIDATE_CATEGORY_SELECT']);
			if ($this->ArraySettings['standard_size_type'] == 'abs')
			{
				$this->_objTpl->setVariable( array(
											'SETTINGS_SELECTED_ABS'	=>	'checked',
											'SETTINGS_SELECTED_PROZ'	=>	'',
											'SETTINGS_THUMBSIZE_ABS_WIDTH_DIS'	=> '',
											'SETTINGS_THUMBSIZE_ABS_HEIGHT_DIS'	=>	'',
											'SETTINGS_THUMBSIZE_PROZ_DIS'	=>	'disabled',
											));				
			}
			else
			{
				$this->_objTpl->setVariable( array(
											'SETTINGS_SELECTED_ABS'	=>	'',
											'SETTINGS_SELECTED_PROZ'	=>	'checked',
											'SETTINGS_THUMBSIZE_ABS_WIDTH_DIS'	=>	'disabled',
											'SETTINGS_THUMBSIZE_ABS_HEIGHT_DIS'	=>	'disabled',
											'SETTINGS_THUMBSIZE_PROZ_DIS'	=>	'',
											));				
			}
			$this->_objTpl->setVariable( array(
											'SETTINGS_THUMBSIZE_ABS_WIDTH'	=>	$this->ArraySettings['standard_width_abs'],
											'SETTINGS_THUMBSIZE_ABS_HEIGHT'	=>	$this->ArraySettings['standard_height_abs']
											));			
			//here starts the category-menu
				$db->query("SELECT id,name
							FROM ".DBPREFIX."module_gallery_categories
							WHERE pid=0 AND status='1'
							ORDER BY sorting");
	
				if ($db->num_rows() > 0)
				{
					while ($db->next_record())
					{
						$arrayMainCategories[$db->f('id')] = $db->f('name');	
					}					
					// $this->objTemplate->set_block("CONTENT_DETAILS","showCategories","handle_showCategories");
					// $this->objTemplate->set_block("CONTENT_DETAILS","showCategoriesSettings","handle_showCategoriesSettings");
					foreach ($arrayMainCategories as $mainCatKey => $mainCatValue)
					{
						$this->_objTpl->setVariable(array(
							'CATEGORY_ID'			=>	$mainCatKey,
							'CATEGORY_NAME'		=>	$mainCatValue,
							'CATEGORY_SPACER'		=>	"",
						));
						$this->_objTpl->parse("showCategoriesSettings");
						
						$this->_objTpl->setVariable(array(
							'CATEGORY_ID'			=>	$mainCatKey,
							'CATEGORY_NAME'		=>	$mainCatValue,
							'CATEGORY_SPACER'		=>	"",
						));
						$this->_objTpl->parse("showCategories");
						
						
						$db->query("SELECT id,name
									FROM ".DBPREFIX."module_gallery_categories
									WHERE pid=".$mainCatKey." AND status='1'
									ORDER BY sorting");
						if ($db->num_rows() > 0)
						{
							while ($db->next_record())
							{					
								$this->_objTpl->setVariable(array(
									CATEGORY_ID			=>	$db->f('id'),
									CATEGORY_NAME		=>	$db->f('name'),
									CATEGORY_SPACER		=>	"&nbsp;&nbsp;&nbsp;",
								));
								$this->_objTpl->parse("showCategories");
								
								$this->_objTpl->setVariable(array(
									CATEGORY_ID			=>	$db->f('id'),
									CATEGORY_NAME		=>	$db->f('name'),
									CATEGORY_SPACER		=>	"&nbsp;&nbsp;&nbsp;",
								));
								$this->_objTpl->parse("showCategoriesSettings");								
								
							}		
						}
					}
				}
				else
				{
					$this->_objTpl->setVariable(array(
						CATEGORY_ID			=>	'',
						CATEGORY_NAME		=>	'',
						CATEGORY_SPACER		=>	'',
					));					
				}
			// here ends the category-menu
			// here start the quality-dropdown
				$this->_objTpl->setCurrentBlock("showThumbQuality");
				
				for ($i = 5; $i <= 100; $i=$i+5)
				{
					$this->_objTpl->setVariable("THUMB_QUALITY_VALUE",$i);
					if ($i >= $this->ArraySettings['standard_quality'] && !$checkerThumbFileQuality)
					{
						$this->_objTpl->setVariable("THUMB_QUALITY_SELECTED","selected");
						$checkerThumbFileQuality = true;
					}
					else
					{
						$this->_objTpl->setVariable("THUMB_QUALITY_SELECTED","");
					}
					$this->_objTpl->parseCurrentBlock();			
				}
			// here ends the quality-dropdown
			// here starts the thumbsize-proz dropdown
				$this->_objTpl->setCurrentBlock("showThumbSizeProz");
				$checkerThumbFileSize = false;
				for ($i = 5; $i <= 100; $i=$i+5)
				{
					$this->_objTpl->setVariable("THUMB_SIZE_VALUE",$i);
					if ($i >= $this->ArraySettings['standard_size_proz'] && !$checkerThumbFileSize)
					{
						$this->_objTpl->setVariable("THUMB_SIZE_SELECTED","selected");
						$checkerThumbFileSize = true;
					} else{
						$this->_objTpl->setVariable("THUMB_SIZE_SELECTED","");
					}
					$this->_objTpl->parseCurrentBlock();
				}			
			// here ends the thumbsize-proz dropdown
				$dirHandle = opendir($this->thumbnailPath);
				while ($dirfile = readdir ($dirHandle)) {
					if (substr($dirfile,0,5) == 'temp_') {
						unlink($this->thumbnailPath.$dirfile);	
					}	
				}
				closedir($dirHandle);				
				srand((double)microtime()*1000000);
				
				$db->query("SELECT *
							FROM ".DBPREFIX."module_gallery_pictures
							WHERE validated='0'
							ORDER BY lastedit ASC
							LIMIT ".$this->ArraySettings['validation_show_limit']);
				
				while ($db->next_record())
				{
					$arrImageCounter[$db->f('id')] = $db->f('id');
					$arrImageInfo[$db->f('id')]['name'] = $db->f('name');
					$arrImageInfo[$db->f('id')]['random_path'] = $this->thumbnailWebPath."temp_".rand()."_".$db->f('path');
					$arrImageInfo[$db->f('id')]['uploadtime'] = date("d.m.Y",$db->f('lastedit'));
					$arrImageInfo[$db->f('id')]['size_o'] = round(filesize($this->imagePath.$db->f('path'))/1024,2);
					$arrFileInfo = getimagesize($this->imagePath.$db->f('path'));
					$arrImageInfo[$db->f('id')]['reso_o'] = $arrFileInfo[0].'x'.$arrFileInfo[1];
					

					if ($db->f('size_type') == 'proz')
					{ // the image sizes are proportional					
						$newThumbnailWidth = floor(($db->f('size_proz')/100) * $arrFileInfo[0]);
						$newThumbnailHeight = floor(($db->f('size_proz')/100) * $arrFileInfo[1]);
						$newThumbnailQuality = $db->f('quality');
					}
					else
					{ // the image sizes are absolute
						$newThumbnailWidth = $db->f('size_abs_w');
						$newThumbnailHeight = $db->f('size_abs_h');
						$newThumbnailQuality = $db->f('quality');
					}
					
					//create thumb
					$this->createImages_JPG_GIF_PNG($this->imagePath, ASCMS_PATH, $db->f('path'), $arrImageInfo[$db->f('id')]['random_path'], $newThumbnailWidth, $newThumbnailHeight, $newThumbnailQuality);

					$arrFileInfo = getimagesize(ASCMS_PATH.$arrImageInfo[$db->f('id')]['random_path']);
					$arrImageInfo[$db->f('id')]['size_t'] = round(filesize(ASCMS_PATH.$arrImageInfo[$db->f('id')]['random_path'])/1024,2);
					$arrImageInfo[$db->f('id')]['reso_t'] = $arrFileInfo[0].'x'.$arrFileInfo[1];
				}

				/*			
				$this->objTemplate->set_block("CONTENT_DETAILS","showImages","handle_showImages");
				$this->objTemplate->set_block("CONTENT_DETAILS","javascriptBlock1","handle_javascriptBlock1");
				$this->objTemplate->set_block("CONTENT_DETAILS","javascriptBlock2","handle_javascriptBlock2");
				$this->objTemplate->set_block("CONTENT_DETAILS","javascriptBlock3","handle_javascriptBlock3");
				$this->objTemplate->set_block("CONTENT_DETAILS","javascriptBlock4","handle_javascriptBlock4");
				$this->objTemplate->set_block("CONTENT_DETAILS","javascriptBlock5","handle_javascriptBlock5");
				$this->objTemplate->set_block("CONTENT_DETAILS","javascriptBlock6","handle_javascriptBlock6");
				$this->objTemplate->set_block("CONTENT_DETAILS","javascriptBlock7","handle_javascriptBlock7");
				*/
				
				$rowColor = 0;
				foreach ($arrImageCounter as $idKey)
				{
					if ($rowColor % 2 == 0)
					{
						$this->_objTpl->setVariable("IMAGES_ROWCLASS",0);
					}
					else
					{
						$this->_objTpl->setVariable("IMAGES_ROWCLASS",1);
					}
					
					$this->_objTpl->setVariable(array(
						IMAGES_ID			=>	$idKey,
						IMAGES_THUMB_SOURCE	=>	$arrImageInfo[$idKey]['random_path'],
						IMAGES_NAME			=>	$arrImageInfo[$idKey]['name'],
						IMAGES_UPLOADDATE	=> 	$arrImageInfo[$idKey]['uploadtime'],	
						IMAGES_SIZE_O		=>	$arrImageInfo[$idKey]['size_o'],
						IMAGES_RESO_O		=> 	$arrImageInfo[$idKey]['reso_o'],
						IMAGES_SIZE_T		=>	$arrImageInfo[$idKey]['size_t'],
						IMAGES_RESO_T		=>	$arrImageInfo[$idKey]['reso_t'],
					));
					
					$this->_objTpl->setVariable("JS_IMAGE_ID1",$idKey);
					$this->_objTpl->setVariable("JS_IMAGE_ID2",$idKey);
					$this->_objTpl->setVariable("JS_IMAGE_ID3",$idKey);
					$this->_objTpl->setVariable("JS_IMAGE_ID4",$idKey);
					$this->_objTpl->setVariable("JS_IMAGE_ID5",$idKey);
					$this->_objTpl->setVariable("JS_IMAGE_ID6",$idKey);
					$this->_objTpl->setVariable("JS_IMAGE_ID7",$idKey);
					
					$this->_objTpl->parse("showImages");
					$this->_objTpl->parse("javascriptBlock1");
					$this->_objTpl->parse("javascriptBlock2");
					$this->_objTpl->parse("javascriptBlock3");
					$this->_objTpl->parse("javascriptBlock4");
					$this->_objTpl->parse("javascriptBlock5");
					$this->_objTpl->parse("javascriptBlock6");
					$this->_objTpl->parse("javascriptBlock7");
					
					$tmpImageId .= $idKey.","; //needed some lines below
					
					$rowColor++;
				}
				
				$tmpImageId = substr($tmpImageId,0,strlen($tmpImageId)-1);
				
				$this->_objTpl->setVariable("HIDDEN_ALL_IMAGES_IDS",$tmpImageId);
				
				// $this->objTemplate->parse("VALIDATE_SHOWDETAILS","CONTENT_DETAILS");
			}
		}
		else
		{
			$this->_objTpl->setVariable("VALIDATE_SHOWDETAILS","");	
		}
    }
    
    
    /*
	* Reload the validation page / Validated a picture / delete a picture
    *
    * @global 	array	$_ARRAYLANG
    * @global	array	$_CONFIG
    * @global	var		$db
    */
    function reloadSingleValidate()
    {    	
    	global $db, $_ARRAYLANG,$_CONFIG;

    	$this->pageTitle = $_ARRAYLANG['TXT_GALLERY_MENU_VALIDATE'];
    	
	    if ($_POST['validate_active'] == 1){
			$insertStatus = 1;	
		} else {
			$insertStatus = 0;	
		}	
    	if (empty($_POST['validate_name']))
    	{ // sets an value into the filename, if there is no name set by the user
    		$_POST['validate_name'] = $_ARRAYLANG['TXT_GALLERY_CATEGORY_NO_NAME'];
    	} else {
			$_POST['validate_name'] = get_magic_quotes_gpc() ? strip_tags($_POST['validate_name']) : addslashes(strip_tags($_POST['validate_name']));
    	}
		if (!isset($_POST['validate_thumb_size']))
		{ // no value, fill in the standard
			$_POST['validate_thumb_size'] = $this->ArraySettings['standard_size_proz'];	
		}
		if (!isset($_POST['validate_thumb_size_abs_height']))
		{// no value, fill in the standard
			$db->query("SELECT path
						FROM ".DBPREFIX."module_gallery_pictures
						WHERE id=".intval($_POST['validate_id']));
			$db->next_record();
			
	    	$arrImageInfo = getimagesize($this->imagePath.$db->f('path'));
	    	
	    	$oldWidth = $arrImageInfo[0];
	    	$oldHeight = $arrImageInfo[1];
	    	$insertWidth = $this->ArraySettings['standard_width_abs'];
	    	$insertHeight = $this->ArraySettings['standard_height_abs'];
	    	   	
	    	if ($insertWidth == 0)
	    	{
	    		$_POST['validate_thumb_size_abs_width'] = round(($oldWidth * $insertHeight) / $oldHeight,0);
	    		$_POST['validate_thumb_size_abs_height'] = $insertHeight;
	    	}
	    	else
	    	{
	    		$_POST['validate_thumb_size_abs_width']	= $insertWidth;
	    		$_POST['validate_thumb_size_abs_height'] = round(($oldHeight * $insertWidth) / $oldWidth,0);
	    	}		
		}    	
    //update button
    	if (isset($_POST['update_button']))
    	{ // the user clicked on the update button  	
		    	$db->query("UPDATE ".DBPREFIX."module_gallery_pictures
		    				SET catid=".intval($_POST['validate_category']).",
		    					status='".$insertStatus."',
		    					name='".$_POST['validate_name']."',
		    					size_type='".addslashes($_POST['validate_thumb_size_selection'])."',
		    					size_proz=".intval($_POST['validate_thumb_size']).",
		    					size_abs_h=".intval($_POST['validate_thumb_size_abs_height']).",
		    					size_abs_w=".intval($_POST['validate_thumb_size_abs_width']).",
		    					quality=".intval($_POST['validate_thumb_quality'])."
		    				WHERE id=".intval($_POST['validate_id']));
	    	
	    		$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_STATUS_MESSAGE_THUMBNAIL_UPDATED'];

    	}
	//submit button   	
    	if (isset($_POST['submit_button']))
    	{ // the user validated the picture
    		if ($_POST['validate_category'] != 0)
    		{
	    		$db->query("UPDATE ".DBPREFIX."module_gallery_pictures
		    				SET catid=".intval($_POST['validate_category']).",
	    						validated='1',
		    					status='".$insertStatus."',
		    					name='".$_POST['validate_name']."',
	    						lastedit=".time().",
		    					size_type='".addslashes($_POST['validate_thumb_size_selection'])."',
		    					size_proz=".intval($_POST['validate_thumb_size']).",
		    					size_abs_h=".intval($_POST['validate_thumb_size_abs_height']).",
		    					size_abs_w=".intval($_POST['validate_thumb_size_abs_width']).",
		    					quality=".intval($_POST['validate_thumb_quality'])."
		    				WHERE id=".intval($_POST['validate_id']));
	    		
	    		// and now create the final thumbnail
				$db->query("SELECT path,size_type,size_proz,size_abs_h,size_abs_w,quality
							FROM ".DBPREFIX."module_gallery_pictures
							WHERE id=".intval($_POST['validate_id']));
				$db->next_record();
				
				$orgPath = $this->imagePath.$db->f('path');
				$thumbPath = $this->thumbnailPath.$db->f('path');
				$arrImageInfos = getimagesize($orgPath);	
							
				if ($db->f('size_type') == 'proz')
				{				
					$newThumbnailWidth = floor(($db->f('size_proz')/100) * $arrImageInfos[0]);
					$newThumbnailHeight = floor(($db->f('size_proz')/100) * $arrImageInfos[1]);
					$newThumbnailQuality = $db->f('quality');
				}
				else
				{						
					$newThumbnailWidth = $db->f('size_abs_w');
					$newThumbnailHeight = $db->f('size_abs_h');
					$newThumbnailQuality = $db->f('quality');
				}		

				//create thumb
				$this->createImages_JPG_GIF_PNG($orgPath, $thumbPath, $fileOld, $fileNew, $newThumbnailWidth, $newThumbnailHeight, $newThumbnailQuality);
				
				$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_STATUS_MESSAGE_THUMBNAIL_VALIDATED'];
    		}
    		else
    		{ // no category was selected, save the values and show an error message
		    	$db->query("UPDATE ".DBPREFIX."module_gallery_pictures
		    				SET catid=".intval($_POST['validate_category']).",
		    					status='".$insertStatus."',
		    					name='".$_POST['validate_name']."',
		    					size_type='".addslashes($_POST['validate_thumb_size_selection'])."',
		    					size_proz=".intval($_POST['validate_thumb_size']).",
		    					size_abs_h=".intval($_POST['validate_thumb_size_abs_height']).",
		    					size_abs_w=".intval($_POST['validate_thumb_size_abs_width']).",
		    					quality=".intval($_POST['validate_thumb_quality'])."
		    				WHERE id=".intval($_POST['validate_id']));    			
    			
    			$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_STATUS_MESSAGE_THUMBNAIL_NO_CATEGORY'];
    		}	
    	}
    //delete button	
    	if (isset($_POST['delete_button']))
    	{ // the user wants to delete this picture
    		$db->query("DELETE
    					FROM ".DBPREFIX."module_gallery_pictures
    					WHERE id=".intval($_POST['validate_id']));
    		
    		$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_STATUS_MESSAGE_PICTURE_DELETED'];
    	}
    }
    
    
    /*
	* Reload the validation page / Validated a picture / delete a picture
    *
    * @global 	array	$_ARRAYLANG
    * @global	array	$_CONFIG
    * @global	var		$db
    */    
    function reloadAllValidate()
    {
    	global $db,$_ARRAYLANG,$_CONFIG;
    	
    	$arrayID = split(",",$_POST['settingsAllImagesIds']);
    	   	
		if ($_POST['settingsFilename'] != 1)
		{ // update the filenames
			foreach ($arrayID as $key => $value)
			{
				$_POST['imageName'.$value] = get_magic_quotes_gpc() ? strip_tags($_POST['imageName'.$value]) : addslashes(strip_tags($_POST['imageName'.$value]));
				$db->query("UPDATE ".DBPREFIX."module_gallery_pictures
							SET name='".$_POST['imageName'.$value]."'
							WHERE id=".intval($value));
			}	
		}
		
		if ($_POST['settingsActive'] != 1)
		{ // set the selected ones to active
			foreach ($arrayID as $key => $value)
			{
				$db->query("UPDATE ".DBPREFIX."module_gallery_pictures
							SET status='".intval($_POST['imageActive'.$value])."'
							WHERE id=".intval($value));
			}					
		}
		
		if ($_POST['settingsCategory'] != 1)
		{ // the user definies the category by himself
			foreach ($arrayID as $key => $value)
			{
				$db->query("UPDATE ".DBPREFIX."module_gallery_pictures
							SET catid=".intval($_POST['imageCategory'.$value])."
							WHERE id=".intval($value));
			}				
		}
		else
		{ // all in the same group
			foreach ($arrayID as $key => $value)
			{
				$db->query("UPDATE ".DBPREFIX."module_gallery_pictures
							SET catid=".intval($_POST['imageCategoryAll'])."
							WHERE id=".intval($value));
			}				
		}
		
    	if (isset($_POST['update_button']))
    	{ // the user clicked on the update button, now i have to calculate the new values sizes for the database
    		foreach ($arrayID as $key => $value)
    		{
    			$db->query("SELECT path
    						FROM ".DBPREFIX."module_gallery_pictures
    						WHERE id=".intval($value));
    			$db->next_record();
    			
		    	$arrImageInfo = getimagesize($this->imagePath.$db->f('path'));
		    	
		    	$oldWidth = $arrImageInfo[0];
		    	$oldHeight = $arrImageInfo[1];
		    	
		    	if (isset($_POST['settingsThumbSizeAbsWidth']))
		    	{
		    		$insertWidth = $_POST['settingsThumbSizeAbsWidth'];
		    	}
		    	else
		    	{
		    		$insertWidth = $this->ArraySettings['standard_width_abs'];
		    	}
		    	
		    	if (isset($_POST['settingsThumbSizeAbsHeight']))
		    	{
		    		$insertHeight = $_POST['settingsThumbSizeAbsHeight'];
		    	}
		    	else
		    	{
		    		$insertHeight = $this->ArraySettings['standard_height_abs'];
		    	}
		    	
		    	$insertQuality = $_POST['settingsThumbQuality'];
		    	$insertType = $_POST['settingsThumbSize'];
		    	 	
		    	if ($insertWidth == 0)
		    	{
		    		$insertWidth = round(($oldWidth * $insertHeight) / $oldHeight,0);
		    	}
		    	else
		    	{
		    		$insertHeight = round(($oldHeight * $insertWidth) / $oldWidth,0);
		    	}    	
	    	
	    		if ($_POST['settingsThumbSize'] == 'abs')
	    		{
	    			$insertSizeProz = $this->ArraySettings['standard_size_proz'];
	    		}
	    		else
	    		{
	    			$insertSizeProz = $_POST['settingsThumbSizeProz'];
	    		}
	    		$db->query("UPDATE ".DBPREFIX."module_gallery_pictures
	    					SET size_type='".addslashes($insertType)."',
	    						size_proz=".intval($insertSizeProz).",
	    						size_abs_h=".intval($insertHeight).",
	    						size_abs_w=".intval($insertWidth).",
	    						quality=".intval($insertQuality)."
	    					WHERE id=".intval($value));
    		}
    	}
    	else
    	{ // the user clicked on the insert button
    		foreach ($arrayID as $key => $value)
    		{
	    		$db->query("UPDATE ".DBPREFIX."module_gallery_pictures
		    				SET validated='1',
	    						lastedit=".time()."
		    				WHERE id=".intval($value));
    			    			    		
	    		// and now create the final thumbnail
				$db->query("SELECT path,size_type,size_proz,size_abs_h,size_abs_w,quality
							FROM ".DBPREFIX."module_gallery_pictures
							WHERE id=".intval($value));
				$db->next_record();
				
				$orgPath = $this->imagePath.$db->f('path');
				$thumbPath = $this->thumbnailPath.$db->f('path');
				$arrImageInfos = getimagesize($orgPath);	
							
				if ($db->f('size_type') == 'proz')
				{				
					$newThumbnailWidth = round(($db->f('size_proz')/100) * $arrImageInfos[0],0);
					$newThumbnailHeight = round(($db->f('size_proz')/100) * $arrImageInfos[1],0);
					$newThumbnailQuality = $db->f('quality');
				}
				else
				{						
					$newThumbnailWidth = $db->f('size_abs_w');
					$newThumbnailHeight = $db->f('size_abs_h');
					$newThumbnailQuality = $db->f('quality');
				}	

				//create thumb
				$this->createImages_JPG_GIF_PNG($orgPath, $thumbPath, $fileOld, $fileNew, $newThumbnailWidth, $newThumbnailHeight, $newThumbnailQuality);
				
				$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_STATUS_MESSAGE_THUMBNAIL_VALIDATED'];   			
    		}
    	}
    }
    
    
    /*
	* Deletes an Image from the database
    *
    * @global 	array	$_ARRAYLANG
    * @global	var		$db
    */    
    function deleteImage($imageId)
    {
    	global $db, $_ARRAYLANG;
    	
    	$db->query("SELECT path
    				FROM ".DBPREFIX."module_gallery_pictures
    				WHERE id=".$imageId);
    	$db->next_record();
    	
    	if (is_file($this->imagePath.$db->f('path'))) {
    		@unlink($this->imagePath.$db->f('path'));
    	}
    	
     	if (is_file($this->thumbnailPath.$db->f('path'))) {
    		@unlink($this->thumbnailPath.$db->f('path'));
    	}   	
    	
    	$db->query("DELETE
    				FROM ".DBPREFIX."module_gallery_pictures
    				WHERE id=".$imageId);
    	
    	$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_STATUS_MESSAGE_PICTURE_DELETED'];
    }


    
    /*
	* Rotates an image clockwise by 90?
    *
    * @global 	array	$_ARRAYLANG
    * @global	array	$_CONFIG
    * @global	var		$db
    */  
    function rotatePicture($imageId)
    {
    	global $db,$_ARRAYLANG,$_CONFIG;
    	
    	$db->query("SELECT path,quality,size_type,size_proz,size_abs_h,size_abs_w
    				FROM ".DBPREFIX."module_gallery_pictures
    				WHERE id=".$imageId);
    	$db->next_record(); 	
    	
        // FIRST I CREATE A NEW ROTATED THUMBNAIL
    
    	$oldFilename = $db->f('path');
 		srand ((double)microtime()*1000000);
    	$newFilename = rand().$oldFilename;
    	
    	$orgPath = $this->imagePath.$oldFilename;
    	$newBigPath = $this->imagePath.$newFilename;
    	$thumbPath = $this->thumbnailPath.$oldFilename;
    	$newPath = $this->thumbnailPath.$newFilename;

		$arrImageInfos_B = getimagesize($orgPath);
		$x_B = $arrImageInfos_B[0];
		$y_B = $arrImageInfos_B[1];    	
    	
    	if ($db->f('size_type') == 'abs') {
	    	$x = $db->f('size_abs_w');
			$y = $db->f('size_abs_h');
			
			$newInsertY = $x;
			$newInsertX = $y;
    	}
    	else {
			$x = round(($db->f('size_proz')/100) * $arrImageInfos_B[0],0);
			$y = round(($db->f('size_proz')/100) * $arrImageInfos_B[1],0);
    	}
			
		$type = $arrImageInfos_B[2];
		
		switch ($type)
		{
			case 1: //GIF
				if($this->gifEnabled==true){
					$src_img = @ImageCreateFromGIF($orgPath);
					$dst_img = @ImageCreate($x-1,$y-1);
					if (!$dst_img) { @ImageCreate($x-1,$y-1); }	
					@ImageCopyResized($dst_img,$src_img,0,0,0,0,$x,$y,$x_B,$y_B);
					$rotated_img = @ImageRotate($dst_img,180,0);
					$rotated_img = @ImageRotate($rotated_img,90,0);
					@ImageGIF($rotated_img,$newPath);	
				}else{
						$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_NO_GIF_SUPPORT'];
				}
			break;
			case 2: //JPG
				if($this->jpgEnabled==true){
					$src_img = ImageCreateFromJpeg($orgPath);
					$dst_img = @ImageCreateTrueColor($x-1,$y-1);
					if (!$dst_img) { @ImageCreate($x-1,$y-1); }	
					@ImageCopyResized($dst_img,$src_img,0,0,0,0,$x,$y,$x_B,$y_B);
					$rotated_img = @ImageRotate($dst_img,180,0);
					$rotated_img = @ImageRotate($rotated_img,90,0);
					@ImageJpeg($rotated_img,$newPath,$db->f('quality'));	
				}else{
						$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_NO_JPG_SUPPORT'];
				}
			break;
			case 3: //PNG
				if($this->pngEnabled==true){
					$src_img = @ImageCreateFromPNG($orgPath);
					@imageAlphaBlending($src_img, true);
					@imageSaveAlpha($src_img, true);
					$dst_img = @ImageCreate($x-1,$y-1);
					if (!$dst_img) { ImageCreate($x-1,$y-1); }	
					@ImageCopyResized($dst_img,$src_img,0,0,0,0,$x,$y,$x_B,$y_B);
					$rotated_img = @ImageRotate($dst_img,180,0);
					$rotated_img = @ImageRotate($rotated_img,90,0);
					@ImagePNG($rotated_img,$newPath,$db->f('quality'));	
				}else{
						$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_NO_PNG_SUPPORT'];
				}
			break;
		}
		@unlink($thumbPath);
		@rename($newPath,$thumbPath);
		
		
    	if ($db->f('size_type') == 'abs') {
			$db->query("UPDATE ".DBPREFIX."module_gallery_pictures
						SET size_abs_h=".$newInsertY.",
							size_abs_w=".$newInsertX."
						WHERE id=".$imageId);
    	}		

    	$type = $arrImageInfos_B[2];
		
		switch ($type)
		{
			case 1: //GIF
				if($this->gifEnabled==true){
					// NOW I ROTATE THE ORIGINAL IMAGE
					$src_img = @imagecreatefromGIF($orgPath);
					$rotated_img = @imagerotate($src_img, 180, 0);
					$rotated_img = @imagerotate($rotated_img, 90, 0);
					@ImageGIF($rotated_img,$newBigPath);
				}else{
						$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_NO_GIF_SUPPORT'];
				}
			break;
			case 2: //JPG
				if($this->jpgEnabled==true){
					// NOW I ROTATE THE ORIGINAL IMAGE
					$src_img = @imagecreatefromjpeg($orgPath);
					$rotated_img = @imagerotate($src_img, 180, 0);
					$rotated_img = @imagerotate($rotated_img, 90, 0);
					@ImageJPEG($rotated_img,$newBigPath);
				}else{
						$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_NO_JPG_SUPPORT'];
				}
			break;
			case 3: //PNG
				if($this->pngEnabled==true){
					// NOW I ROTATE THE ORIGINAL IMAGE
					$src_img = @imagecreatefromPNG($orgPath);
					@imageAlphaBlending($src_img, true);
					@imageSaveAlpha($src_img, true);
					$rotated_img = imagerotate($src_img, 180, 0);
					$rotated_img = imagerotate($rotated_img, 90, 0);
					@ImagePNG($rotated_img,$newBigPath);
				}else{
						$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_NO_PNG_SUPPORT'];
				}
			break;
		}
		unlink($orgPath);
		rename($newBigPath,$orgPath);
	 }
	 
	 /*
	* import Pictures
	* import requires chmod 777 in folder gallery_import
    *
    * @global	array	$_ARRAYLANG
    */     
    function importPicture()
    {
    	global $_ARRAYLANG;
    	
    	$this->_objTpl->loadTemplateFile('module_gallery_import_pictures.html',true,true);
    	
    	//get enabled filetypes
		$enabledTypes = array();

		if($this->gifEnabled == true){
			$enabledTypes[] = 1;
		}
		
		if($this->jpgEnabled == true){
			$enabledTypes[] = 2;
		}
		
		if($this->pngEnabled == true){
			$enabledTypes[] = 3;
		}
		
		//get images
		$o=0;
    	$fd = @opendir($this->importPath);
		while($name = @readdir($fd)){
			if($name != "." && $name != ".."){
				if(is_file($this->importPath . $name) && $o < $this->maxEntries){
					$fileInfo=getimagesize($this->importPath.$name);
					//if(in_array($type, $enabledTypes)){
						$this->importFiles['name'][] = $name;
						$this->importFiles['size'][] = $this->_getSize($this->importPath.$name);
						$this->importFiles['type'][] = $this->_getType($this->importPath.$name);
						$this->importFiles['typeEnabled'][] = $fileInfo[2];
						$this->importFiles['height'][] = $fileInfo[1];
						$this->importFiles['width'][] = $fileInfo[0];
						$o++;
					//}
				}
			}
		}	
		@closedir($fd);
	    clearstatcache();
    	 
 		$this->_objTpl->setVariable(array(
			'TXT_TITLE'							=>	$_ARRAYLANG['TXT_GALLERY_MENU_UPLOAD_FORM'],
			'TXT_IMAGENUMBER'					=>	$_ARRAYLANG['TXT_GALLERY_UPLOAD_FORM_IMAGE_NUMBER'],
			'TXT_IMPORT_MAKE_SELECTION'			=>	$_ARRAYLANG['TXT_GALLERY_MAKE_SELECTION'],
			'TXT_IMPORT_DELETE_PICTURE'			=>  $_ARRAYLANG['TXT_GALLERY_REALY_DELETE'],
			'TXT_MAX_PICTURES'					=>  $_ARRAYLANG['TXT_GALLERY_MAX_PICTURES']." ".$this->maxEntries." ".$_ARRAYLANG['TXT_GALLERY_COUNT_PICTURES'].$o,
			'IMPORT_IMAGE_TREE_NAV_MAIN'      	=> 'http://' . $_SERVER['HTTP_HOST'] . $this->importWebPath
		));
	
		// empty dir or php safe mode restriction
    	if($o==0 || !@opendir($this->importPath)){
    	    if(!@opendir($this->importPath)) {
    	        $tmpMessage = 'PHP Safe Mode Restriction!';
    	    } else{
    	        $tmpMessage = "Dieses Verzeichnis ist leer.";
    	    }
    	    
    	    $this->_objTpl->setVariable(array(
    	        'TXT_IMPORT_IMAGE_DIR_EMPTY'   => $tmpMessage,
    	    ));
    	    $this->_objTpl->parse('importEmptyDirectory');
    	}
    	// not empty dir (select action)
    	else{   
    		//importDirectoryTree
			$i=0;
			$this->_objTpl->setCurrentBlock("importDirectoryTree");
    		
			asort($this->importFiles['name']);
			
			foreach($this->importFiles['name'] as $picKey => $picName){
				$class = ($i % 2) ? 'row2' : 'row1';
				if(in_array($this->importFiles['typeEnabled'][$picKey], $enabledTypes)){
					$this->_objTpl->setVariable(array(
						'IMPORT_IMAGE_DIR_TREE_ROW'			=>	$class,
						'IMPORT_IMAGE_NAME'					=>	$picName,
						'IMPORT_IMAGE_HEIGHT'				=>	$this->importFiles['height'][$picKey]+25,
						'IMPORT_IMAGE_WIDTH'				=>	$this->importFiles['width'][$picKey]+20,	
						'IMPORT_IMAGE_PATH'					=>	$this->importWebPath.$picName,
						'IMPORT_IMAGE_TYP'					=>	$this->importFiles['type'][$picKey],
						'IMPORT_IMAGE_SIZE'					=>	$this->importFiles['size'][$picKey],
						'IMPORT_IMAGE_KEY'					=>	$picKey,
						'IMPORT_IMAGE_CHECKBOX'				=>  "<input type=checkbox title=Select ".$picName." name=formSelected[] value=".$picName." />",
					));
				}else{
					$this->_objTpl->setVariable(array(
						'IMPORT_IMAGE_DIR_TREE_ROW'			=>	$class,
						'IMPORT_IMAGE_NAME'					=>	$picName,
						'IMPORT_IMAGE_HEIGHT'				=>	$this->importFiles['height'][$picKey]+25,
						'IMPORT_IMAGE_WIDTH'				=>	$this->importFiles['width'][$picKey]+20,	
						'IMPORT_IMAGE_PATH'					=>	$this->importWebPath.$picName,	
						'IMPORT_IMAGE_TYP'					=>	$this->importFiles['type'][$picKey],
						'IMPORT_IMAGE_SIZE'					=>	$this->importFiles['size'][$picKey],
						'IMPORT_IMAGE_KEY'					=>	$picKey,
						'IMPORT_IMAGE_CHECKBOX'				=>  "&nbsp;",
						'IMPORT_IMAGE_NAME_ATTRIBUT'		=>	"<i><font color=#ff0000>(".$_ARRAYLANG['TXT_GALLERY_TYPE_NOT_SUPPORTED'].")</font></i>"
					));
				}
				$i++;
				$this->_objTpl->parseCurrentBlock("importDirectoryTree");
			} 
    		
    		$this->_objTpl->setVariable(array(
    	        'TXT_IMPORT_IMAGE_SELECT_ACTION'  	=> $_ARRAYLANG['TXT_GALLERY_CHOOSE_ACTION'],
    	        'TXT_IMPORT_IMAGE_IMPORT'         	=> $_ARRAYLANG['TXT_GALLERY_IMPORT'],
    	        'TXT_IMPORT_IMAGE_DELETE'         	=> $_ARRAYLANG['TXT_GALLERY_DELETE']
    	        
    	    ));
    	    $this->_objTpl->parse('importSelectAction');
    	}
    }
    
     /*
	* get filesize
    *
    * @param	$file
    */
    function _getSize($file)
    {
        if(is_file($file)){
            if(@filesize($file)){
                $size = filesize($file);
            }
        }
        
        (!isset($size) or empty($size)) ? $size = '0' : '';
 
        return $size;        
    }
    
    /*
	* get filesize
    *
    * @param	$file
    */
    function _getType($file)
    {
        if(is_file($file)){
            $info = pathinfo($file);
		    $type = strtoupper($info['extension']);
        }
        
        if(is_dir($file)){
            $type = '[folder]';
        }
        
        (!isset($type) or empty($type)) ? $type = '-' : '';
        
        return $type;
    }
    
    /*
	* import selected pictures
    *
    */
    function importFromFolder()
    {
		foreach($_POST["formSelected"] as $picKey => $picName){
			$picName = get_magic_quotes_gpc() ? strip_tags($picName) : addslashes(strip_tags($picName));
			$this->movePicture($picName);
		}	
    }
    
    /*
	* move pictures from gallery_import to gallery
    *
    * @param	$file
    */
    function movePicture($file){
    	//check if file exists
    	$checker = false;
		while ($checker == false){
			if (file_exists($this->imagePath.$file)){
				$importedImageName = time() . '_' . $file;
			}else{
				$importedImageName = $file;		
			}
			$checker = true;
		}
		
		$size=getimagesize($this->importPath.$file);
		$width=$size[0];
		$height=$size[1];
		
		$this->createImages_JPG_GIF_PNG($this->importPath, $this->imagePath, $file, $importedImageName, $width, $height, 100);
		
		//insert image in db
		$DatabasePath = $importedImageName;
		$this->insertImage($DatabasePath,$importedImageName);
		
		//delet imported images
		if(file_exists($this->imagePath.$importedImageName)){
			unlink($this->importPath.$file);
		}
    }
    
    /*
	* delete selected pictures
    *
    */
    function deleteImportPicture()
    {
        if(!isset($_GET["pic"])){
        	foreach($_POST["formSelected"] as $picKey => $picName){
        		unlink($this->importPath.$picName);
        	}
        }else{
        	unlink($this->importPath.$_GET["pic"]);
        }
    }
    
    /*
	* delete selected pictures
    *
    */
    function createImages_JPG_GIF_PNG($pathOld, $pathNew, $fileOld, $fileNew, $newWidth, $newHeight, $quality)
    {
        //copy image
		$size=getimagesize($pathOld.$fileOld); //ermittelt die Gre des Bildes 
		$width=$size[0]; //die Breite des Bildes 
		$height=$size[1]; //die Hhe des Bildes 
		$type=$size[2]; //type des Bildes
		
		if(!isset($quality)){
			$quality = 100;
		}
		
		switch ($type)
		{
			case 1: //GIF
				if($this->gifEnabled==true){
					$im1 = ImageCreateFromGIF($pathOld.$fileOld); 
					$im2 = @ImageCreate($newWidth,$newHeight);
					ImageCopyResized($im2, $im1, 0,0, 0,0,$newWidth,$newHeight, $width,$height); 
					ImageGIF($im2, $pathNew.$fileNew); 
					
					imagedestroy($im1); //Speicherabbild wieder lschen 
					imagedestroy($im2); //Speicherabbild wieder lschen
				}else{
						$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_NO_GIF_SUPPORT'];
				}
			break;
			case 2: //JPG
				if($this->jpgEnabled==true){
					$im1=imagecreatefromjpeg($pathOld.$fileOld); //erstellt ein Abbild im Speicher 
					$im2=@imagecreatetruecolor($newWidth,$newHeight);
					imagecopyresized($im2, $im1, 0,0, 0,0,$newWidth,$newHeight, $width,$height);
					imagejpeg($im2, $pathNew.$fileNew, $quality); //Bild am neuen ort speichern 
					
					imagedestroy($im1); //Speicherabbild wieder lschen 
					imagedestroy($im2); //Speicherabbild wieder lschen
				}else{
						$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_NO_JPG_SUPPORT'];
				}
			break;
			case 3: //PNG
				if($this->pngEnabled==true){
					$im1=imagecreatefrompng($pathOld.$fileOld); //erstellt ein Abbild im Speicher 
					imageAlphaBlending($im1, true);
					imageSaveAlpha($im1, true);
					$im2=@imagecreate($newWidth,$newHeight);
					imagecopyresized($im2, $im1, 0,0, 0,0,$newWidth,$newHeight, $width,$height);
					imagePNG($im2, $pathNew.$fileNew); //Bild am neuen ort speichern 
					
					imagedestroy($im1); //Speicherabbild wieder lschen 
					imagedestroy($im2); //Speicherabbild wieder lschen
				}else{
						$this->statusMessage = $_ARRAYLANG['TXT_GALLERY_NO_PNG_SUPPORT'];
				}
			break;
		}
    }
}
?>